#!/system/bin/sh
#--------------------------------------------------------------------------------
#FastTurbo Boost V4.x                                                           
#Author:@Chenzyadb (xda,coolapk,bilibili,github,gitee)       
#E-Mail:chenzyadb@qq.com 
#Test:@Chinatsu Moss & @Amakuni Moss 
#Opensource Licence : https://gitee.com/chenzyadb/FastTurbo/blob/master/LICENCE
#Copyright © Chenzyadb 2020 All Rights Reserved.
#--------------------------------------------------------------------------------
LOG="/data/FastTurbo/FastTurbo.log"
#FastTurbo Function
chmod 7777 /system/bin/write 
chmod 7777 /system/bin/chwrite
function count_num() {
 FT_PASS=`echo $(($FT_PASS + 1))`
}
#得到SOC型号
SOC="null"
SOC=$(getprop ro.board.platform)
if [ $SOC = "null" ] ; then
SOC=$(getprop ro.chipname)
fi
#得到GPU信息
if [ -e /sys/class/kgsl/kgsl-3d0/devfreq/governor ] ; then
#通用adreno位置
GPU_DIR="/sys/class/kgsl/kgsl-3d0"
GPU_SUB="adreno"
elif [ -e /sys/devices/soc.0/1c00000.qcom,kgsl-3d0/kgsl/kgsl-3d0/devfreq/governor ] ; then
GPU_DIR="/sys/devices/soc.0/1c00000.qcom,kgsl-3d0/kgsl/kgsl-3d0"
GPU_SUB="adreno"
elif [ -d /sys/devices/platform/kgsl-3d0.0/kgsl/kgsl-3d0/ ] ; then
GPU_DIR="/sys/devices/platform/kgsl-3d0.0/kgsl/kgsl-3d0/"
GPU_SUB="adreno"
elif [ -d "/sys/class/misc/mali0/device" ]; then
#通用mali位置
GPU_DIR="/sys/class/misc/mali0/device"
GPU_SUB="mali"
elif [ -d "/sys/devices/platform/mali.0" ]; then
GPU_DIR="/sys/devices/platform/mali.0"
GPU_SUB="mali"
elif [ -d "/sys/module/mali/parameters" ]; then
GPU_DIR="/sys/module/mali/parameters"
GPU_SUB="mali"
elif [ -d "/sys/class/misc/mali0/" ]; then
GPU_DIR="/sys/class/misc/mali0/"
GPU_SUB="mali"
fi
echo "$GPU_DIR" > /data/FastTurbo/SmartAI/gpu_dir
echo "$GPU_SUB" > /data/FastTurbo/SmartAI/gpu_sub
GPU_MIN="0"
GPU_MAX="0"
if [ $GPU_SUB = "adreno" ] ; then
 if [ -e $GPU_DIR/devfreq/max_freq ] ; then
  GPU_MIN=$(cat $GPU_DIR/devfreq/min_freq)
  GPU_MAX=$(cat $GPU_DIR/devfreq/max_freq)
 elif [ -e $GPU_DIR/max_gpuclk ] ; then
  GPU_MAX=$(cat $GPU_DIR/max_gpuclk)
 fi
elif [ $GPU_SUB = "mali" ] ; then
 if [ -e $GPU_DIR/devfreq/gpufreq/max_freq ] ; then
  GPU_MIN=$(cat $GPU_DIR/devfreq/gpufreq/min_freq)
  GPU_MAX=$(cat $GPU_DIR/devfreq/gpufreq/max_freq)
 fi
fi
#得到CPU信息
if [ -e /sys/devices/system/cpu/kernel_max ] ; then
core_num=$(cat /sys/devices/system/cpu/kernel_max)
elif [ -d /sys/devices/system/cpu/cpu9/ ] ; then
core_num="9"
elif [ -d /sys/devices/system/cpu/cpu7/ ] ; then
core_num="7"
elif [ -d /sys/devices/system/cpu/cpu5/ ] ; then
core_num="5"
elif [ -d /sys/devices/system/cpu/cpu3/ ] ; then
core_num="3"
fi
if [ -e /sys/devices/system/cpu/cpu0/core_ctl/min_cpus ] ; then
min_core_num_1=$(cat /sys/devices/system/cpu/cpu0/core_ctl/min_cpus)
min_core_num_2=$(cat /sys/devices/system/cpu/cpu4/core_ctl/min_cpus)
soc_thermal_on="false"
else
soc_thermal_on="false"
fi
if [ -d /sys/devices/system/cpu/cpu0/cpufreq/ ] ; then
no_freq="false"
freq0="null"
freq1="null"
freq2="null"
freq3="null"
freq4="null"
freq5="null"
freq6="null"
freq7="null"
freq8="null"
freq9="null"
available_freq_1="null"
available_freq_2="null"
available_freq_3="null"
available_freq_4="null"
available_freq_5="null"
available_freq_a="null"
if [ -e /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies ] ; then
available_freq_1=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu4/cpufreq/scaling_available_frequencies ] ; then
available_freq_2=$(cat /sys/devices/system/cpu/cpu4/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu8/cpufreq/scaling_available_frequencies ] ; then
available_freq_3=$(cat /sys/devices/system/cpu/cpu8/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu6/cpufreq/scaling_available_frequencies ] ; then
available_freq_4=$(cat /sys/devices/system/cpu/cpu6/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu3/cpufreq/scaling_available_frequencies ] ; then
available_freq_5=$(cat /sys/devices/system/cpu/cpu3/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu2/cpufreq/scaling_available_frequencies ] ; then
available_freq_a=$(cat /sys/devices/system/cpu/cpu2/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu0/cpufreq/cpuinfo_max_freq ] ; then
freq0=$(cat /sys/devices/system/cpu/cpu0/cpufreq/cpuinfo_max_freq)
elif [ -e /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq ] ; then
freq0=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq)
fi
if [ -e /sys/devices/system/cpu/cpu1/cpufreq/cpuinfo_max_freq ] ; then
freq1=$(cat /sys/devices/system/cpu/cpu1/cpufreq/cpuinfo_max_freq)
elif [ -e /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq ] ; then
freq1=$(cat /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq)
fi
if [ -e /sys/devices/system/cpu/cpu2/cpufreq/cpuinfo_max_freq ] ; then
freq2=$(cat /sys/devices/system/cpu/cpu2/cpufreq/cpuinfo_max_freq)
elif [ -e /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq ] ; then
freq2=$(cat /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq)
fi
if [ -e /sys/devices/system/cpu/cpu3/cpufreq/cpuinfo_max_freq ] ; then
freq3=$(cat /sys/devices/system/cpu/cpu3/cpufreq/cpuinfo_max_freq)
elif [ -e /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq ] ; then
freq3=$(cat /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq)
fi
if [ -e /sys/devices/system/cpu/cpu4/cpufreq/cpuinfo_max_freq ] ; then
freq4=$(cat /sys/devices/system/cpu/cpu4/cpufreq/cpuinfo_max_freq)
elif [ -e /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq ] ; then
freq4=$(cat /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq)
fi
if [ -e /sys/devices/system/cpu/cpu5/cpufreq/cpuinfo_max_freq ] ; then
freq5=$(cat /sys/devices/system/cpu/cpu5/cpufreq/cpuinfo_max_freq)
elif [ -e /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq ] ; then
freq5=$(cat /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq)
fi
if [ -e /sys/devices/system/cpu/cpu6/cpufreq/cpuinfo_max_freq ] ; then
freq6=$(cat /sys/devices/system/cpu/cpu6/cpufreq/cpuinfo_max_freq)
elif [ -e /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq ] ; then
freq6=$(cat /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq)
fi
if [ -e /sys/devices/system/cpu/cpu7/cpufreq/cpuinfo_max_freq ] ; then
freq7=$(cat /sys/devices/system/cpu/cpu7/cpufreq/cpuinfo_max_freq)
elif [ -e /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq ] ; then
freq7=$(cat /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq)
fi
if [ -e /sys/devices/system/cpu/cpu8/cpufreq/cpuinfo_max_freq ] ; then
freq8=$(cat /sys/devices/system/cpu/cpu8/cpufreq/cpuinfo_max_freq)
elif [ -e /sys/devices/system/cpu/cpu8/cpufreq/scaling_max_freq ] ; then
freq8=$(cat /sys/devices/system/cpu/cpu8/cpufreq/scaling_max_freq)
fi
if [ -e /sys/devices/system/cpu/cpu9/cpufreq/cpuinfo_max_freq ] ; then 
freq9=$(cat /sys/devices/system/cpu/cpu9/cpufreq/cpuinfo_max_freq)
elif [ -e /sys/devices/system/cpu/cpu9/cpufreq/scaling_max_freq ] ; then
freq9=$(cat /sys/devices/system/cpu/cpu9/cpufreq/scaling_max_freq)
fi
else
no_freq="true"
fi
if [ $core_num = "7" ] ; then
if [ ${min_core_num_1} -lt 4 ] ; then
soc_thermal_on="true"
else
soc_thermal_on="false"
fi
if [ ${min_core_num_2} -lt 4 ] ; then
soc_thermal_on="true"
else
soc_thermal_on="false"
fi
elif [ $core_num = "5" ] ; then
if [ ${min_core_num_1} -lt 4 ] ; then
soc_thermal_on="true"
else
soc_thermal_on="false"
fi
if [ ${min_core_num_2} -lt 4 ] ; then
soc_thermal_on="true"
else
soc_thermal_on="false"
fi
elif [ $core_num = "3" ] ; then
if [ ${min_core_num_1} -lt 4 ] ; then
soc_thermal_on="true"
else
soc_thermal_on="false"
fi
fi
if [ -e /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_governors ] ; then
CPU_GOV_SUPPORT=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_governors)
else
CPU_GOV_SUPPORT=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_governor)
fi
#得到RAM信息
# ram_value=$(free | grep Mem | awk '{print $2}') 旧的方法已弃用
MEM_INFO=$(cat /proc/meminfo | grep MemTotal)
ram_value_right=`echo ${MEM_INFO#*:}`
ram_value=`echo ${ram_value_right%kB*}`
#得到电池信息
BATTERY_UNKNOWN="true"
if [ -d /sys/class/power_supply/battery/ ] ; then
BATTERY_UNKNOWN="false"
BATTERY_TEC=$(cat /sys/class/power_supply/battery/technology)
BATTERY_HEALTH=$(cat /sys/class/power_supply/battery/health)
elif [ -d /sys/class/power_supply/Battery/ ] ; then
BATTERY_UNKNOWN="false"
BATTERY_TEC=$(cat /sys/class/power_supply/Battery/technology)
BATTERY_HEALTH=$(cat /sys/class/power_supply/Battery/health)
fi
#得到闪存信息
if [ -e /sys/block/sda/size ] ; then
ROM_TYPE="UFS"
if [ -e /proc/scsi/scsi ] ; then
UFS_MODEL=$(sed -n 3p /proc/scsi/scsi)
else
UFS_MODEL="unknown"
fi
else
ROM_TYPE="eMMC"
UFS_MODEL="unknown"
fi
#得到模块配置参数
mainfile_lose="false"
if [ -e /data/FastTurbo/mode ] ; then
mode=$(cat /data/FastTurbo/mode)
else
mode="balance"
echo "balance" > /data/FastTurbo/mode
fi
if [ -e /data/FastTurbo/temp_fix ] ; then 
temp_fix=$(cat /data/FastTurbo/temp_fix)
else
temp_fix="false"
echo "false" > /data/FastTurbo/temp_fix
fi
if [ -e /data/FastTurbo/net_fix ] ; then
net_fix=$(cat /data/FastTurbo/net_fix)
else
net_fix="false"
echo "false" > /data/FastTurbo/net_fix
fi
if [ -e /data/FastTurbo/kernel_fix ] ; then
kernel_fix=$(cat /data/FastTurbo/kernel_fix)
else
kernel_fix="false"
echo "false" > /data/FastTurbo/kernel_fix
fi
if [ -e /data/FastTurbo/google_fix ] ; then
google_fix=$(cat /data/FastTurbo/google_fix)
else
google_fix="false"
echo "false" > /data/FastTurbo/google_fix
fi
if [ -e /data/FastTurbo/prop_fix ] ; then
prop_fix=$(cat /data/FastTurbo/prop_fix)
else
prop_fix="false"
echo "false" > /data/FastTurbo/prop_fix
fi
if [ -e /data/FastTurbo/touch_fix ] ; then
touch_fix=$(cat /data/FastTurbo/touch_fix)
else
touch_fix="false"
echo "false" > /data/FastTurbo/touch_fix
fi
if [ -e /data/FastTurbo/vm_fix ] ; then
vm_fix=$(cat /data/FastTurbo/vm_fix)
else
vm_fix="false"
echo "false" > /data/FastTurbo/vm_fix
fi
if [ -e /data/FastTurbo/io_fix ] ; then
io_fix=$(cat /data/FastTurbo/io_fix)
else
io_fix="false"
echo "false" > /data/FastTurbo/io_fix
fi
if [ -e /data/FastTurbo/lpl_fix ] ; then
lpl_fix=$(cat /data/FastTurbo/lpl_fix)
else
lpl_fix="false"
echo "false" > /data/FastTurbo/lpl_fix
fi
if [ -e /data/FastTurbo/dse_fix ] ; then
dse_fix=$(cat /data/FastTurbo/dse_fix)
else
dse_fix="false"
echo "false" > /data/FastTurbo/dse_fix
fi
if [ -e /data/FastTurbo/dns_fix ] ; then
dns_fix=$(cat /data/FastTurbo/dns_fix)
else
dns_fix="false"
echo "false" > /data/FastTurbo/dns_fix
fi
if [ -e /data/FastTurbo/uksm_fix ] ; then
uksm_fix=$(cat /data/FastTurbo/uksm_fix)
else
uksm_fix="false"
echo "false" > /data/FastTurbo/uksm_fix
fi
if [ -e /data/FastTurbo/deepsleep_fix ] ; then
deepsleep_fix=$(cat /data/FastTurbo/deepsleep_fix)
else
deepsleep_fix="false"
echo "false" > /data/FastTurbo/deepsleep_fix
fi
if [ -e /data/FastTurbo/drw_fix ] ; then
drw_fix=$(cat /data/FastTurbo/drw_fix)
else
drw_fix="false"
echo "false" > /data/FastTurbo/drw_fix
fi
if [ -e /data/FastTurbo/use_eas ] ; then
use_eas=$(cat /data/FastTurbo/use_eas)
else
use_eas="false"
echo "false" > /data/FastTurbo/use_eas
fi
if [ -e /data/FastTurbo/smai_mode ] ; then
smai_mode=$(cat /data/FastTurbo/smai_mode)
else
smai_mode="stop"
echo "stop" > /data/FastTurbo/smai_mode
fi
if [ -e /data/FastTurbo/ram_fix ] ; then
ram_fix=$(cat /data/FastTurbo/ram_fix)
else
ram_fix="true"
echo "true" > /data/FastTurbo/ram_fix
fi
#得到手机信息
GPU_INFO=""
if [ $GPU_SUB = "mali" ] ; then
if [ -e $GPU_DIR/gpuinfo ] ; then
GPU_INFO=$(cat $GPU_DIR/gpuinfo)
fi
fi
if [ -e /sys/fs/selinux/enforce ] ; then
SEL_OFF=$(cat /sys/fs/selinux/enforce)
else
SEL_OFF="1"
fi
SDK=$(getprop ro.build.version.sdk)
android_verison=$(getprop ro.build.version.release)
producer=$(getprop ro.product.manufacturer)
model=$(getprop ro.product.model)
cpu_abi_info=$(getprop ro.product.cpu.abi)
cpu_abi64_info=$(getprop ro.product.cpu.abilist64)
ROM=$(getprop ro.build.display.id) 
KERNEL=$(uname -r) 
#手机和模块信息显示
echo "=========================" |  tee -a $LOG;
echo "* SOC型号：$SOC" |  tee -a $LOG;
echo "* CPU指令集：$cpu_abi_info" |  tee -a $LOG;
echo "* Android 版本: $android_verison" |  tee -a $LOG;
echo "* Android SDK: $SDK" |  tee -a $LOG;
echo "* 制造商：$producer" |  tee -a $LOG;
echo "* 手机型号：$model" |  tee -a $LOG;
echo "* ROM：$ROM" |  tee -a $LOG;
echo "* 内核: $KERNEL" |  tee -a $LOG;
if [ $SEL_OFF = "1" ] ; then
echo "* SELinux 未关闭" |  tee -a $LOG;
else
echo "* SELinux 已关闭" |  tee -a $LOG;
fi
if [ $BATTERY_UNKNOWN = "false" ] ; then
echo "* 电池技术: $BATTERY_TEC" |  tee -a $LOG;
echo "* 电池健康: $BATTERY_HEALTH" |  tee -a $LOG;
else
echo "* 不支持电池信息查看" |  tee -a $LOG;
fi
if [ $freq0 != "null" ] ; then
echo "* 核心频率获取完毕，频率列表如下：" |  tee -a $LOG;
 if [ $core_num = "3" ] ; then
  echo "* $(($freq0/1000))mhz $(($freq1/1000))mhz $(($freq2/1000))mhz $(($freq3/1000))mhz " |  tee -a $LOG;
 elif [ $core_num = "5" ] ; then
  echo "* $(($freq0/1000))mhz $(($freq1/1000))mhz $(($freq2/1000))mhz $(($freq3/1000))mhz " |  tee -a $LOG;
  echo "* $(($freq4/1000))mhz $(($freq5/1000))mhz " |  tee -a $LOG;
 elif [ $core_num = "7" ] ; then
  echo "* $(($freq0/1000))mhz $(($freq1/1000))mhz $(($freq2/1000))mhz $(($freq3/1000))mhz " |  tee -a $LOG;
  echo "* $(($freq4/1000))mhz $(($freq5/1000))mhz $(($freq6/1000))mhz $(($freq7/1000))mhz " |  tee -a $LOG;
 elif [ $core_num = "9" ] ; then
  echo "* $(($freq0/1000))mhz $(($freq1/1000))mhz $(($freq2/1000))mhz $(($freq3/1000))mhz " |  tee -a $LOG;
  echo "* $(($freq4/1000))mhz $(($freq5/1000))mhz $(($freq6/1000))mhz $(($freq7/1000))mhz " |  tee -a $LOG;
 echo "* $(($freq8/1000))mhz $(($freq9/1000))mhz" |  tee -a $LOG;
 fi
else
echo "* CPU 频率获取失败." |  tee -a $LOG;
fi
echo "* 闪存类型：$ROM_TYPE" |  tee -a $LOG;
echo "* 闪存信息：$UFS_MODEL" |  tee -a $LOG;
echo "* 内存大小：$(($ram_value/1024))mb" |  tee -a $LOG;
if [ $GPU_SUB = "adreno" ] ; then
echo "* GPU供应商：Qualcomm Adreno" |  tee -a $LOG;
elif [ $GPU_SUB = "mali" ] ; then
echo "* GPU供应商：ARM Mali" |  tee -a $LOG;
else
echo "* GPU供应商：unknown " |  tee -a $LOG;
fi
if [ $GPU_SUB = "mali" ] ; then
echo "* GPU型号：$GPU_INFO " |  tee -a $LOG;
fi
echo "* GPU频率：$(($GPU_MAX/1000000))mhz" |  tee -a $LOG;
echo "* FastTurbo处于$mode模式" |  tee -a $LOG;
echo "=========================" |  tee -a $LOG;
#====================CPUCHECK====================
if [ $core_num = "9" ] ; then
if [ ${freq0} -gt ${freq9} ] ; then
MFREQ=`echo ${freq0}` 
else
MFREQ=`echo ${freq9}` 
fi
elif [ $core_num = "7" ] ; then
if [ ${freq0} -gt ${freq7} ] ; then
MFREQ=`echo ${freq0}` 
else
MFREQ=`echo ${freq7}` 
fi
elif [ $core_num = "5" ] ; then
if [ ${freq0} -gt ${freq5} ] ; then
MFREQ=`echo ${freq0}` 
else
MFREQ=`echo ${freq5}` 
fi
elif [ $core_num = "3" ] ; then
if [ ${freq0} -gt ${freq9} ] ; then
MFREQ=`echo ${freq0}` 
else
MFREQ=`echo ${freq3}` 
fi
fi
echo "[CPU_CHECK] Main_Freq: $(($MFREQ/1000))MHz " |  tee -a $LOG;
if [ $cpu_abi_info = "armeabi-v7a" ] ; then
SC_CPU_ABI="32"
elif [ $cpu_abi_info = "arm64-v8a" ] ; then
SC_CPU_ABI="64"
else
SC_CPU_ABI="null"
if [ $cpu_abi64_info = "" ] ; then 
SC_CPU_ABI="32"
else
SC_CPU_ABI="64"
fi
fi
soc_type="null" #SOC类型
soc_special="0" #非常规核心配置SOC类型
#0=none ; 1=2big,6little ; 2=1big,7little ; 3=1big,3mid,4little ; 4=1big,3little ; 5=8mid (snapdragon625,450)
case $SOC in "msm8916"*) #snapdragon410
soc_type="low" 
soc_special="0" 
esac
case $SOC in "msm8939"*) #snapdragon615/616
soc_type="low" 
soc_special="0" 
esac
case $SOC in "msm8952"*) #snapdragon617
soc_type="low" 
soc_special="5" 
esac
case $SOC in "msm8917"*) #snapdragon425
soc_type="low" 
soc_special="0" 
esac
case $SOC in "msm8920"*) #snapdragon427
soc_type="low" 
soc_special="0" 
esac
case $SOC in "msm8937"*) #snapdragon430
soc_type="low" 
soc_special="0" 
esac
case $SOC in "msm8940"*) #snapdragon435
soc_type="low" 
soc_special="0" 
esac
case $SOC in "msm8974"*) #snapdragon80x
soc_type="low" 
soc_special="0" 
esac
case $SOC in "msm8084"*) #snapdragon805
soc_type="low" 
soc_special="0" 
esac
case $SOC in "apq8084"*) #snapdragon805
soc_type="low" 
soc_special="0" 
esac
case $SOC in "msm8953"*) #snapdragon625/626
soc_type="low" 
soc_special="5" 
esac
case $SOC in "msm8956"*) #snapdragon650
soc_type="low" 
soc_special="0" 
esac
case $SOC in "msm8976"*) #snapdragon652
soc_type="low" 
soc_special="0" 
esac
case $SOC in "msm8992"*) #snapdragon808
soc_type="low" 
soc_special="0" 
esac
case $SOC in "msm8994"*) #snapdragon810
soc_type="mid" 
soc_special="0" 
esac
case $SOC in "msm8996"*) #snapdragon82x
soc_type="mid" 
soc_special="0" 
esac
case $SOC in "msm8998"*) #snapdragon835
soc_type="high" 
soc_special="0" 
esac
case $SOC in "sdm845"*) #snapdragon845
soc_type="high" 
soc_special="0" 
esac
case $SOC in "sdm855"*) #snapdragon855
soc_type="high" 
soc_special="3" 
esac
case $SOC in "msmnile"*) #snapdragon855
soc_type="high" 
soc_special="3" 
esac
case $SOC in "sdm865"*) #snapdragon865
soc_type="high" 
soc_special="3" 
esac
case $SOC in "keno"*) #snapdragon865
soc_type="high" 
soc_special="3" 
esac
case $SOC in "sdm710"*) #snapdragon710
soc_type="high" 
soc_special="2" 
esac
case $SOC in "sdm720"*) #snapdragon720
soc_type="high" 
soc_special="2" 
esac
case $SOC in "sdm730"*) #snapdragon730
soc_type="high" 
soc_special="2" 
esac
case $SOC in "sdm765"*) #snapdragon765
soc_type="high" 
soc_special="2" 
esac
case $SOC in "sdm660"*) #snapdragon660
soc_type="mid" 
soc_special="0" 
esac
case $SOC in "sdm662"*) #snapdragon662
soc_type="mid" 
soc_special="0" 
esac
case $SOC in "sdm665"*) #snapdragon665
soc_type="mid" 
soc_special="0" 
esac
case $SOC in "sdm670"*) #snapdragon670
soc_type="high" 
soc_special="2" 
esac
case $SOC in "sdm675"*) #snapdragon675
soc_type="high" 
soc_special="2" 
esac
case $SOC in "sdm690"*) #snapdragon690
soc_type="high" 
soc_special="2" 
esac
case $SOC in "sdm439"*) #snapdragon439
soc_type="low" 
soc_special="0" 
esac
case $SOC in "sdm450"*) #snapdragon450
soc_type="low" 
soc_special="5" 
esac
case $SOC in "sdm460"*) #snapdragon460
soc_type="mid" 
soc_special="0" 
esac
case $SOC in "mt6735"*) #Cortex-A53 * 4
soc_type="low" 
soc_special="0" 
esac
case $SOC in "mt6750"*) #Cortex-A53 * 8
soc_type="low" 
soc_special="0" 
esac
case $SOC in "mt6752"*) #Cortex-A53 * 8
soc_type="low" 
soc_special="0" 
esac
case $SOC in "mt6753"*) #Cortex-A53 * 8
soc_type="low" 
soc_special="0" 
esac
case $SOC in "mt6755"*) #Helio P1x
soc_type="low" 
soc_special="0" 
esac
case $SOC in "mt6757"*) #Helio P2x
soc_type="low" 
soc_special="0" 
esac
case $SOC in "mt6763"*) #Helio P23
soc_type="low" 
soc_special="0" 
esac
case $SOC in "mt6765"*) #Helio P35
soc_type="low" 
soc_special="0" 
esac
case $SOC in "mt6795"*) #Helio X10
soc_type="low" 
soc_special="5" 
esac
case $SOC in "mt6797"*) #Helio X2x
soc_type="mid" 
soc_special="0" 
JP_SUPPORT="unsupport"
echo "unsupport" > /data/FastTurbo/jp_function
esac
case $SOC in "mt6799"*) #Helio X30
soc_type="high" 
soc_special="0" 
JP_SUPPORT="unsupport"
echo "unsupport" > /data/FastTurbo/jp_function
esac
if [ $soc_type = "null" ] ; then #通过自动算法获取CPU信息
if [ $SC_CPU_ABI = "64" ] ; then
if [ $core_num = "7" ] ; then
if [ ${freq0} -eq ${freq7} ] ; then
 soc_special="5"
 if [ ${freq0} -gt 2950000 ] ; then
  soc_type="high"
 elif [ ${freq0} -gt 2300000 ] ; then
  soc_type="mid"
 else
  soc_type="low"
 fi
elif [ ${freq0} -eq ${freq3} -a ${freq3} -ne ${freq4} ] ; then 
 if [ ${freq0} -gt ${freq7} ] ; then
  if [ ${freq0} -gt 2300000 ] ; then
   soc_type="high"
  elif [ ${freq0} -gt 1800000 ] ; then
   if [ ${freq7} -gt 1400000 ] ; then
	soc_type="mid"  
   else
    soc_type="low" 
   fi
  else
   soc_type="low"
  fi
 else
  if [ ${freq7} -gt 2300000 ] ; then
   soc_type="high" 
  elif [ ${freq7} -gt 1800000 ] ; then
   if [ ${freq0} -gt 1400000 ] ; then
	soc_type="mid"  
   else
    soc_type="low" 
   fi
  else
   soc_type="low"
  fi
 fi
elif [ ${freq2} -eq ${freq7} -a ${freq0} -eq ${freq1} ] ; then
   if [ ${freq0} -gt 2000000 ] ; then
    soc_type="high"
   else
    soc_type="mid"
   fi
   soc_special="1"
elif [ ${freq0} -eq ${freq5} -a ${freq6} -eq ${freq7} ] ; then
   if [ ${freq7} -gt 2000000 ] ; then
    soc_type="high"
   else
    soc_type="mid"
   fi
   soc_special="1"
fi
elif [ $core_num = "5" ] ; then
if [ ${freq0} -gt ${freq5} ] ; then
 if [ ${freq0} -gt 2300000 ] ; then
  soc_type="mid"
  else
  soc_type="low"
 fi
else
 if [ ${freq5} -gt 2300000 ] ; then
  soc_type="mid"
  else
  soc_type="low"
 fi
fi
elif [ $core_num = "3" ] ; then
 if [ $SOC = "msm8996" ] ; then
 #snapdragon 820/821 
 soc_type="mid"
 else
 if [ ${freq0} -eq ${freq3} ] ; then
 soc_type="low"
 fi
 fi
elif [ $core_num = "9" ] ; then
if [ ${freq0} -gt ${freq9} ] ; then
if [ ${freq0} -gt 2300000 ] ; then
soc_type="high"
else
soc_type="mid"
fi
else
if [ ${freq9} -gt 2300000 ] ; then
soc_type="high"
else
soc_type="mid"
fi
fi
fi
elif [ $SC_CPU_ABI = "32" ] ; then
if [ $core_num = "7" ] ; then
if [ ${freq0} -eq ${freq7} ] ; then
  soc_type="low"
elif [ ${freq4} -eq ${freq7} -a ${freq0} -eq ${freq3} ] ; then
 if [ ${freq0} -gt ${freq7} ] ; then
  if [ ${freq0} -gt 2400000 ] ; then
   if [ ${freq7} -gt 1700000 ] ; then
	soc_type="mid"  
   else
    soc_type="low" 
   fi
  else
   soc_type="low"
  fi
 else
  if [ ${freq7} -gt 2400000 ] ; then
   if [ ${freq0} -gt 1700000 ] ; then
	soc_type="mid"  
   else
    soc_type="low" 
   fi
  else
   soc_type="low"
  fi
 fi
fi
elif [ $core_num = "3" ] ; then
 if [ ${freq0} -gt 2800000 ] ; then
 soc_type="mid"
 else
 soc_type="low"
 fi
fi
fi
fi
if [ $soc_type = "high" ] ; then
 echo "[CPU_CHECK] 检测到 $SC_CPU_ABI 位高端CPU." |  tee -a $LOG;
elif [ $soc_type = "mid" ] ; then
 echo "[CPU_CHECK] 检测到 $SC_CPU_ABI 位中端CPU." |  tee -a $LOG;
elif [ $soc_type = "low" ] ; then
 echo "[CPU_CHECK] 检测到 $SC_CPU_ABI 位低端CPU." |  tee -a $LOG;
fi
echo "$soc_special" > /data/FastTurbo/SmartAI/soc_special
#=================================================
#================available_freq check=============
use_smart_freq="1"
if [ $soc_thermal_on = "true" ] ; then
 if [ $core_num = "9" ] ; then
  if [ ${freq0} -gt ${freq9} ] ; then
   if [ $available_freq_1 = "null" ] ; then
    use_smart_freq="0"
   else
    use_smart_freq="1"
   fi
  else
   if [ $available_freq_3 = "null" ] ; then
    use_smart_freq="0"
   else
    use_smart_freq="1"
   fi
  fi
 elif [ $core_num = "7" ] ; then
  if [ $soc_special = "0" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    if [ $available_freq_1 = "null" ] ; then
     use_smart_freq="0"
    else
     use_smart_freq="1"
    fi
   else
    if [ $available_freq_2 = "null" ] ; then
     use_smart_freq="0"
    else
     use_smart_freq="1"
    fi
   fi
  elif [ $soc_special = "5" ] ; then
   if [ $available_freq_1 = "null" ] ; then
    use_smart_freq="0"
   else
    use_smart_freq="1"
   fi
  fi 
 elif [ $core_num = "5" ] ; then
  if [ ${freq0} -gt ${freq5} ] ; then
   if [ $available_freq_1 = "null" ] ; then
    use_smart_freq="0"
   else
    use_smart_freq="1"
   fi
  else
   if [ $available_freq_2 = "null" ] ; then
    use_smart_freq="0"
   else
    use_smart_freq="1"
   fi
  fi  
 elif [ $core_num = "3" ] ; then
  if [ $soc_special = "0" ] ; then
   if [ $available_freq_1 = "null" ] ; then
    use_smart_freq="0"
   else
    use_smart_freq="1"
   fi
  fi
 fi 
fi
#=================================================
#SmartCore----------------------------------------
INFO_DIR="/data/FastTurbo/SmartCore_Files"  
if [ -d /data/FastTurbo/SmartCore_Files/ ] ; then
CPU_GOVERNOR=$(cat $INFO_DIR/cpu_governor)
fi
if [ -e $INFO_DIR/cpu_governor ] ; then
if [ $CPU_GOVERNOR = "interactive" ] ; then
PREFER_HMP="true"
EAS_GOVERNOR="null"
elif [ $CPU_GOVERNOR = "ondemand" ] ; then
PREFER_HMP="true"
EAS_GOVERNOR="null"
elif [ $CPU_GOVERNOR = "schedutil" ] ; then
PREFER_HMP="false"
EAS_GOVERNOR="schedutil"
elif [ $CPU_GOVERNOR = "sched" ] ; then
PREFER_HMP="false"
EAS_GOVERNOR="sched"
elif [ $CPU_GOVERNOR = "blu_schedutil" ] ; then
PREFER_HMP="false"
EAS_GOVERNOR="blu_schedutil"
elif [ $CPU_GOVERNOR = "pwrutil" ] ; then
PREFER_HMP="false"
EAS_GOVERNOR="pwrutil"
elif [ $CPU_GOVERNOR = "pwrutilx" ] ; then
PREFER_HMP="false"
EAS_GOVERNOR="pwrutilx"
else
PREFER_HMP="false"
EAS_GOVERNOR="schedutil"
fi
fi
if [ $EAS_GOVERNOR = "null" ] ; then  #内核默认调频器非EAS,检测内核支持的EAS.
if [ $(echo $CPU_GOV_SUPPORT | grep schedutil ) != "" ] ; then
EAS_GOVERNOR="schedutil"
elif [ $(echo $CPU_GOV_SUPPORT | grep sched ) != "" ] ; then
EAS_GOVERNOR="sched"
elif [ $(echo $CPU_GOV_SUPPORT | grep blu_schedutil ) != "" ] ; then
EAS_GOVERNOR="blu_schedutil"
elif [ $(echo $CPU_GOV_SUPPORT | grep pwrutil ) != "" ] ; then
EAS_GOVERNOR="pwrutil"
elif [ $(echo $CPU_GOV_SUPPORT | grep pwrutilx ) != "" ] ; then
EAS_GOVERNOR="pwrutilx"
fi
fi
if [ ! -e /dev/stune/background/schedtune.boost ] ; then
PREFER_HMP="true"
EAS_GOVERNOR="null"
fi
#-------------------------------------------------
#Write CPU Freqs to SmartAbility------------------
if [ $core_num = "9" ] ; then
echo "$freq0" > /data/FastTurbo/SmartAI/cpu_freq0 
echo "$freq1" > /data/FastTurbo/SmartAI/cpu_freq1 
echo "$freq2" > /data/FastTurbo/SmartAI/cpu_freq2 
echo "$freq3" > /data/FastTurbo/SmartAI/cpu_freq3 
echo "$freq4" > /data/FastTurbo/SmartAI/cpu_freq4 
echo "$freq5" > /data/FastTurbo/SmartAI/cpu_freq5 
echo "$freq6" > /data/FastTurbo/SmartAI/cpu_freq6 
echo "$freq7" > /data/FastTurbo/SmartAI/cpu_freq7 
echo "$freq8" > /data/FastTurbo/SmartAI/cpu_freq8 
echo "$freq9" > /data/FastTurbo/SmartAI/cpu_freq9 
elif [ $core_num = "7" ] ; then
echo "$freq0" > /data/FastTurbo/SmartAI/cpu_freq0 
echo "$freq1" > /data/FastTurbo/SmartAI/cpu_freq1 
echo "$freq2" > /data/FastTurbo/SmartAI/cpu_freq2 
echo "$freq3" > /data/FastTurbo/SmartAI/cpu_freq3 
echo "$freq4" > /data/FastTurbo/SmartAI/cpu_freq4 
echo "$freq5" > /data/FastTurbo/SmartAI/cpu_freq5 
echo "$freq6" > /data/FastTurbo/SmartAI/cpu_freq6 
echo "$freq7" > /data/FastTurbo/SmartAI/cpu_freq7 
elif [ $core_num = "5" ] ; then
echo "$freq0" > /data/FastTurbo/SmartAI/cpu_freq0 
echo "$freq1" > /data/FastTurbo/SmartAI/cpu_freq1 
echo "$freq2" > /data/FastTurbo/SmartAI/cpu_freq2 
echo "$freq3" > /data/FastTurbo/SmartAI/cpu_freq3 
echo "$freq4" > /data/FastTurbo/SmartAI/cpu_freq4 
echo "$freq5" > /data/FastTurbo/SmartAI/cpu_freq5 
elif [ $core_num = "3" ] ; then
echo "$freq0" > /data/FastTurbo/SmartAI/cpu_freq0 
echo "$freq1" > /data/FastTurbo/SmartAI/cpu_freq1 
echo "$freq2" > /data/FastTurbo/SmartAI/cpu_freq2 
echo "$freq3" > /data/FastTurbo/SmartAI/cpu_freq3 
fi
#Check before RUN --------------------------------
if [ $core_num = "1" ] ; then
echo "[ERROR] FastTurbo 不支持双核处理器优化! " |  tee -a $LOG;
exit 0
fi
if [ $use_eas = "true" ] ; then
if [ ! -e /dev/stune/background/schedtune.boost ] ; then
echo "[ERROR] 检测到内核不支持EAS! " |  tee -a $LOG;
echo "* 已自动切换为HMP调度. " |  tee -a $LOG;
use_eas="false"
elif [ $EAS_GOVERNOR = "null" ] ; then
echo "[ERROR] 检测到内核不支持包含EAS调度的调频器! " |  tee -a $LOG;
echo "* 你可以尝试修改/data/FastTurbo/SmartCore_Files/下的cpu_governor文件. " |  tee -a $LOG;
echo "* 已自动切换为HMP调度. " |  tee -a $LOG;
use_eas="false"
elif [ $PREFER_HMP = "true" ] ; then
echo "[WARNING] 检测到内核默认为非EAS调频器! " |  tee -a $LOG;
echo "* 可能存在兼容性问题. " |  tee -a $LOG;
fi
fi
if [ $soc_thermal_on = "true" ] ; then
echo "unsupport" > /data/FastTurbo/jp_function
fi
#--------------------------------------------------
#初始化计数----------------------------------------
FT_PASS="0"
#--------------------------------------------------
#Stop Thermal
stop "perfd"
stop "thermald"
stop "mpdecision"
stop "thermal-engine"
stop "perf-hal-1-0"
#Stop extra BOOST
if [ -e /sys/power/pnpmgr/touch_boost ]; then
 count_num
 chwrite "0" /sys/power/pnpmgr/touch_boost 
fi
if [ -e /data/system/perfd/default_values ]; then
rm /data/system/perfd/default_values
count_num
fi
case $SOC in mt*)
#MediaTek
#setprop ro.mtk_perfservice_support 0
#chwrite 0 "/proc/sys/kernel/sched_tunable_scaling"
#chwrite 0 "/proc/ppm/policy/hica_is_limit_big_freq"
chwrite 0 "/proc/hps/enabled"
esac
echo "[LOG] Boost & Performence 优化完毕." |  tee -a $LOG;
#--------------------------------------------------
#调整快充温控阈值----------------------------------
if [ $temp_fix = "true" ] ; then
if [ -e /sys/class/power_supply/bms/temp_warm ] ; then
count_num
if [ $mode = "gamexe" ] ; then
chwrite 500 /sys/class/power_supply/bms/temp_warm
elif [ $mode = "turbo" ] ; then
chwrite 450 /sys/class/power_supply/bms/temp_warm
else
chwrite 400 /sys/class/power_supply/bms/temp_warm
fi
echo "[LOG] 快充温度阈值优化完毕." |  tee -a $LOG;
fi
fi
#--------------------------------------------------
#启动所有核心--------------------------------------
if [ $soc_thermal_on = "true" ] ; then
if [ $soc_special = "0" ] ; then
if [ -e /sys/devices/system/cpu/cpu4/core_ctl/min_cpus ] ; then
count_num
if [ $core_num = "7" ] ; then
chwrite 4 /sys/devices/system/cpu/cpu0/core_ctl/max_cpus 
chwrite 4 /sys/devices/system/cpu/cpu4/core_ctl/max_cpus 
chwrite 4 /sys/devices/system/cpu/cpu0/core_ctl/min_cpus 
chwrite 4 /sys/devices/system/cpu/cpu4/core_ctl/min_cpus 
elif [ $core_num = "5" ] ; then
chwrite 4 /sys/devices/system/cpu/cpu0/core_ctl/max_cpus 
chwrite 2 /sys/devices/system/cpu/cpu4/core_ctl/max_cpus 
chwrite 4 /sys/devices/system/cpu/cpu0/core_ctl/min_cpus 
chwrite 2 /sys/devices/system/cpu/cpu4/core_ctl/min_cpu
elif [ $core_num = "3" ] ; then
chwrite 4 /sys/devices/system/cpu/cpu0/core_ctl/max_cpus 
chwrite 4 /sys/devices/system/cpu/cpu0/core_ctl/min_cpus 
elif [ $core_num = "9" ] ; then
if [ ${freq0} -gt ${freq9} ] ; then
chwrite 2 /sys/devices/system/cpu/cpu0/core_ctl/max_cpus 
chwrite 4 /sys/devices/system/cpu/cpu2/core_ctl/max_cpus 
chwrite 4 /sys/devices/system/cpu/cpu5/core_ctl/max_cpus 
chwrite 2 /sys/devices/system/cpu/cpu0/core_ctl/min_cpus 
chwrite 4 /sys/devices/system/cpu/cpu2/core_ctl/min_cpus 
chwrite 4 /sys/devices/system/cpu/cpu5/core_ctl/min_cpus
else
chwrite 2 /sys/devices/system/cpu/cpu8/core_ctl/max_cpus 
chwrite 4 /sys/devices/system/cpu/cpu4/core_ctl/max_cpus 
chwrite 4 /sys/devices/system/cpu/cpu0/core_ctl/max_cpus 
chwrite 2 /sys/devices/system/cpu/cpu8/core_ctl/min_cpus 
chwrite 4 /sys/devices/system/cpu/cpu4/core_ctl/min_cpus 
chwrite 4 /sys/devices/system/cpu/cpu0/core_ctl/min_cpus
fi
fi
fi
fi
fi
if [ -e /sys/devices/system/cpu/cpu1/online ] ; then
count_num
#将所有核心启动
if [ $core_num = "9" ] ; then
chwrite 1 /sys/devices/system/cpu/cpu0/online 
echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
chwrite 1 /sys/devices/system/cpu/cpu1/online 
echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
chwrite 1 /sys/devices/system/cpu/cpu2/online 
echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
chwrite 1 /sys/devices/system/cpu/cpu3/online 
echo "1" > /data/FastTurbo/SmartAI/cpu3_online 
chwrite 1 /sys/devices/system/cpu/cpu4/online 
echo "1" > /data/FastTurbo/SmartAI/cpu4_online 
chwrite 1 /sys/devices/system/cpu/cpu5/online 
echo "1" > /data/FastTurbo/SmartAI/cpu5_online 
chwrite 1 /sys/devices/system/cpu/cpu6/online 
echo "1" > /data/FastTurbo/SmartAI/cpu6_online 
chwrite 1 /sys/devices/system/cpu/cpu7/online 
echo "1" > /data/FastTurbo/SmartAI/cpu7_online 
chwrite 1 /sys/devices/system/cpu/cpu8/online 
echo "1" > /data/FastTurbo/SmartAI/cpu8_online 
chwrite 1 /sys/devices/system/cpu/cpu9/online 
echo "1" > /data/FastTurbo/SmartAI/cpu9_online
elif [ $core_num = "7" ] ; then
chwrite 1 /sys/devices/system/cpu/cpu0/online 
echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
chwrite 1 /sys/devices/system/cpu/cpu1/online 
echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
chwrite 1 /sys/devices/system/cpu/cpu2/online 
echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
chwrite 1 /sys/devices/system/cpu/cpu3/online 
echo "1" > /data/FastTurbo/SmartAI/cpu3_online 
chwrite 1 /sys/devices/system/cpu/cpu4/online 
echo "1" > /data/FastTurbo/SmartAI/cpu4_online 
chwrite 1 /sys/devices/system/cpu/cpu5/online 
echo "1" > /data/FastTurbo/SmartAI/cpu5_online 
chwrite 1 /sys/devices/system/cpu/cpu6/online 
echo "1" > /data/FastTurbo/SmartAI/cpu6_online 
chwrite 1 /sys/devices/system/cpu/cpu7/online 
echo "1" > /data/FastTurbo/SmartAI/cpu7_online
elif [ $core_num = "5" ] ; then
chwrite 1 /sys/devices/system/cpu/cpu0/online 
echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
chwrite 1 /sys/devices/system/cpu/cpu1/online 
echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
chwrite 1 /sys/devices/system/cpu/cpu2/online 
echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
chwrite 1 /sys/devices/system/cpu/cpu3/online 
echo "1" > /data/FastTurbo/SmartAI/cpu3_online 
chwrite 1 /sys/devices/system/cpu/cpu4/online 
echo "1" > /data/FastTurbo/SmartAI/cpu4_online 
chwrite 1 /sys/devices/system/cpu/cpu5/online 
echo "1" > /data/FastTurbo/SmartAI/cpu5_online 
elif [ $core_num = "3" ] ; then
chwrite 1 /sys/devices/system/cpu/cpu0/online 
echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
chwrite 1 /sys/devices/system/cpu/cpu1/online 
echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
chwrite 1 /sys/devices/system/cpu/cpu2/online 
echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
chwrite 1 /sys/devices/system/cpu/cpu3/online 
echo "1" > /data/FastTurbo/SmartAI/cpu3_online 
fi
echo "[LOG] CPU Online 优化完毕." |  tee -a $LOG;
fi
#-------------------------------------------------
#修改build.prop-----------------------------------
if [ $prop_fix = "true" ] ; then
count_num
if [ $mode = "turbo" ] ; then
setprop view.touch_slop 40
setprop view.minimum_fling_velocity 80
setprop view.scroll_friction 0.0001
setprop wifi.supplicant_scan_interval 180
setprop ro.ril.def.agps.mode 2
setprop pm.sleep_mode 2
setprop video.accelerate.hw 1
setprop debug.sf.hw 1
setprop windowsmgr.max_events_per_sec 280
setprop debug.sf.latch_unsignaled 1
setprop debug.performance.tuning 1
setprop ro.min_pointer_dur 0.0001
setprop ro.min.pointer.dur 0.0001
setprop sys.use_fifo_ui 1
setprop debug.hwui.disable_vsync false
setprop debug.sqlite.syncmode OFF
echo "[LOG] $mode 模式 system.prop 优化完毕." |  tee -a $LOG;
elif [ $mode = "balance" ] ; then
setprop view.touch_slop 40
setprop view.minimum_fling_velocity 80
setprop view.scroll_friction 0.0001
setprop wifi.supplicant_scan_interval 180
setprop ro.ril.def.agps.mode 2
setprop pm.sleep_mode 2
setprop video.accelerate.hw 1
setprop debug.sf.hw 0
setprop windowsmgr.max_events_per_sec 280
setprop debug.sf.latch_unsignaled 1
setprop debug.performance.tuning 1
setprop ro.min_pointer_dur 0.0001
setprop ro.min.pointer.dur 0.0001
setprop sys.use_fifo_ui 1
setprop debug.hwui.disable_vsync false
setprop debug.sqlite.syncmode ON
echo "[LOG] $mode 模式 system.prop 优化完毕." |  tee -a $LOG;
elif [ $mode = "gamexe" ] ; then
setprop view.touch_slop 40
setprop view.minimum_fling_velocity 80
setprop view.scroll_friction 0.0001
setprop wifi.supplicant_scan_interval 180
setprop ro.ril.def.agps.mode 2
setprop pm.sleep_mode 2
setprop video.accelerate.hw 1
setprop debug.sf.hw 1
setprop windowsmgr.max_events_per_sec 280
setprop debug.sf.latch_unsignaled 1
setprop debug.performance.tuning 1
setprop ro.min_pointer_dur 0.0001
setprop ro.min.pointer.dur 0.0001
setprop sys.use_fifo_ui 1
setprop debug.hwui.disable_vsync true
setprop debug.sqlite.syncmode OFF
echo "[LOG] $mode 模式 system.prop 优化完毕." |  tee -a $LOG;
elif [ $mode = "powersave" ] ; then
setprop view.touch_slop 40
setprop view.minimum_fling_velocity 80
setprop view.scroll_friction 0.002
setprop wifi.supplicant_scan_interval 180
setprop ro.ril.def.agps.mode 0
setprop pm.sleep_mode 1
setprop video.accelerate.hw 0
setprop debug.sf.hw 0
setprop windowsmgr.max_events_per_sec 280
setprop debug.sf.latch_unsignaled 1
setprop debug.performance.tuning 0
setprop ro.min_pointer_dur 0.002
setprop ro.min.pointer.dur 0.002
setprop sys.use_fifo_ui 0
setprop debug.hwui.disable_vsync false
setprop debug.sqlite.syncmode ON
echo "[LOG] $mode 模式 system.prop 优化完毕." |  tee -a $LOG;
fi
fi
#--------------------------------------------------
#优化网络连接--------------------------------------
if [ $net_fix = "true" ] ; then
count_num
sysctl -e -w net.ipv4.tcp_timestamps=0
sysctl -e -w net.ipv4.tcp_sack=1
sysctl -e -w net.ipv4.tcp_fack=1
sysctl -e -w net.ipv4.tcp_window_scaling=1
sysctl -e -w net.ipv4.tcp_congestion_control="cubic"
echo "[LOG] TCP & web_connect 优化完毕." | tee -a $LOG;
fi
#--------------------------------------------------
#DNS优化-------------------------------------------
if [ $dns_fix = "true" ] ; then
count_num
#Baidu DNS  Aliyun DNS
iptables -t nat -A OUTPUT -p udp --dport 53 -j DNAT --to 180.76.76.76:53
iptables -t nat -I OUTPUT -p udp --dport 53 -j DNAT --to 180.76.76.76:53
iptables -t nat -A OUTPUT -p tcp --dport 53 -j DNAT --to 223.5.5.5:53
iptables -t nat -I OUTPUT -p tcp --dport 53 -j DNAT --to 223.5.5.5:53
ip6tables -t nat -A OUTPUT -p tcp --dport 53 -j DNAT --to [2400:da00::6666]:5353
ip6tables -t nat -I OUTPUT -p tcp --dport 53 -j DNAT --to [2400:da00::6666]:5353
setprop net.eth0.dns1 180.76.76.76
setprop net.eth0.dns2 223.5.5.5
setprop net.dns1 180.76.76.76
setprop net.dns2 223.5.5.5
setprop net.ppp0.dns1 180.76.76.76
setprop net.ppp0.dns2 223.5.5.5
setprop net.rmnet0.dns1 180.76.76.76
setprop net.rmnet0.dns2 223.5.5.5
setprop net.rmnet1.dns1 180.76.76.76
setprop net.rmnet1.dns2 223.5.5.5
setprop net.rmnet2.dns1 180.76.76.76
setprop net.rmnet2.dns2 223.5.5.5
setprop net.pdpbr1.dns1 180.76.76.76
setprop net.pdpbr1.dns2 223.5.5.5
setprop net.wlan0.dns1 180.76.76.76
setprop net.wlan0.dns2 223.5.5.5
setprop 2400:da00::6666:5353
echo "[LOG] DNS 优化完毕." | tee -a $LOG;
fi
#--------------------------------------------------
#内核调试------------------------------------------
if [ $kernel_fix = "true" ] ; then
count_num
sysctl -e -w kernel.panic_on_oops=0
sysctl -e -w kernel.panic=0
echo "[LOG] Linux Kernel 优化完毕." |  tee -a $LOG;
fi
#--------------------------------------------------
#优化Google套件------------------------------------
if [ $google_fix = "true" ] ; then
count_num
su -c "pm disable com.google.android.gms/com.google.android.gms.mdm.receivers.MdmDeviceAdminReceiver"
su -c "pm enable com.google.android.gms/.ads.AdRequestBrokerService"
su -c "pm enable com.google.android.gms/.ads.identifier.service.AdvertisingIdService"
su -c "pm enable com.google.android.gms/.ads.social.GcmSchedulerWakeupService"
su -c "pm enable com.google.android.gms/.analytics.AnalyticsService"
su -c "pm enable com.google.android.gms/.analytics.service.PlayLogMonitorIntervalService"
su -c "pm enable com.google.android.gms/.backup.BackupTransportService"
su -c "pm enable com.google.android.gms/.update.SystemUpdateActivity"
su -c "pm enable com.google.android.gms/.update.SystemUpdateService"
su -c "pm enable com.google.android.gms/.update.SystemUpdateService\$ActiveReceiver"
su -c "pm enable com.google.android.gms/.update.SystemUpdateService\$Receiver"
su -c "pm enable com.google.android.gms/.update.SystemUpdateService\$SecretCodeReceiver"
su -c "pm enable com.google.android.gms/.thunderbird.settings.ThunderbirdSettingInjectorService"
su -c "pm enable com.google.android.gsf/.update.SystemUpdateActivity"
su -c "pm enable com.google.android.gsf/.update.SystemUpdatePanoActivity"
su -c "pm enable com.google.android.gsf/.update.SystemUpdateService"
su -c "pm enable com.google.android.gsf/.update.SystemUpdateService\$Receiver"
su -c "pm enable com.google.android.gsf/.update.SystemUpdateService\$SecretCodeReceiver"
echo "[LOG] Google APPS 优化完毕." |  tee -a $LOG;
fi
#---------------------------------------------------
#优化触控-------------------------------------------
if [ $touch_fix = "true" ] ; then
if [ -e /sys/kernel/fp_boost/enabled ] ; then
 count_num
 chwrite "1" /sys/kernel/fp_boost/enabled 
 echo "[LOG] 触控优化 已启用." |  tee -a $LOG;
fi
fi
#---------------------------------------------------
#Deep Sleep Enhancement-----------------------------
if [ -d /sys/class/scsi_disk/ ] ; then
count_num
for i in $($B ls /sys/class/scsi_disk/); do
 chwrite 'temporary none' '/sys/class/scsi_disk/$i/cache_type';
done;
echo "[LOG] Deep Sleep Enhancement 优化完毕." |  tee -a $LOG;
fi
#---------------------------------------------------
#GPU优化--------------------------------------------
if [ $GPU_SUB = "adreno" ] ; then
if [ -e $GPU_DIR/devfreq/governor ] ; then
count_num
#Qualcomm GPU
chwrite "simple_ondemand" $GPU_DIR/devfreq/governor
#simple_ondemand is the best GPU governor.
fi
fi
if [ $GPU_SUB = "mali" ] ; then
if [ -e $GPU_DIR/devfreq/gpufreq/governor ] ; then
count_num
#Mali GPU
chwrite "mali_ondemand" $GPU_DIR/devfreq/gpufreq/governor
#mali_ondemand is the best GPU governor.
fi
fi
if [ $GPU_SUB = "adreno" ] ; then
#Qualcomm
GPU_HIGH=$(cat $GPU_DIR/num_pwrlevels)
if [ -d $GPU_DIR/ ] ; then
count_num
if [ $mode = "gamexe" ] ; then
chwrite $GPU_MAX "$GPU_DIR/max_gpuclk" 
chwrite $GPU_MAX "$GPU_DIR/devfreq/target_freq"  
chwrite $GPU_MAX "$GPU_DIR/devfreq/cur_freq" 
chwrite 0 "$GPU_DIR/max_pwrlevel" 
chwrite $GPU_HIGH "$GPU_DIR/min_pwrlevel" 
elif [ $mode = "turbo" ] ; then
chwrite $GPU_MAX "$GPU_DIR/max_gpuclk" 
chwrite $GPU_MAX "$GPU_DIR/devfreq/target_freq"  
chwrite $GPU_MAX "$GPU_DIR/devfreq/cur_freq" 
chwrite 0 "$GPU_DIR/max_pwrlevel" 
echo "0" > /data/FastTurbo/SmartAI/adreno_maxpwrlevel 
chwrite $GPU_HIGH "$GPU_DIR/min_pwrlevel" 
elif [ $mode = "balance" ] ; then
chwrite $GPU_MAX "$GPU_DIR/max_gpuclk" 
chwrite $GPU_MIN "$GPU_DIR/devfreq/target_freq" 
chwrite $GPU_MIN "$GPU_DIR/devfreq/cur_freq" 
if [ ${#GPU_HIGH} -gt 10 ] ; then
 chwrite 3 "$GPU_DIR/max_pwrlevel"
 echo "3" > /data/FastTurbo/SmartAI/adreno_maxpwrlevel
elif [ ${#GPU_HIGH} -gt 6 ] ; then
 chwrite 2 "$GPU_DIR/max_pwrlevel"
 echo "2" > /data/FastTurbo/SmartAI/adreno_maxpwrlevel
else
 chwrite 1 "$GPU_DIR/max_pwrlevel"
 echo "1" > /data/FastTurbo/SmartAI/adreno_maxpwrlevel
fi
chwrite $GPU_HIGH "$GPU_DIR/min_pwrlevel" 
chwrite "6000" /sys/module/adreno_idler/parameters/adreno_idler_idleworkload  
chwrite '15' /sys/module/adreno_idler/parameters/adreno_idler_downdifferential 
chwrite '15' /sys/module/adreno_idler/parameters/adreno_idler_idlewait
elif [ $mode = "powersave" ] ; then
if [ ${#GPU_HIGH} -gt 10 ] ; then
 chwrite 4 "$GPU_DIR/max_pwrlevel"
 echo "4" > /data/FastTurbo/SmartAI/adreno_maxpwrlevel
elif [ ${#GPU_HIGH} -gt 6 ] ; then
 chwrite 3 "$GPU_DIR/max_pwrlevel"
 echo "3" > /data/FastTurbo/SmartAI/adreno_maxpwrlevel
else
 chwrite 2 "$GPU_DIR/max_pwrlevel"
 echo "2" > /data/FastTurbo/SmartAI/adreno_maxpwrlevel
fi
if [ -e /sys/module/adreno_idler/parameters/adreno_idler_idlewait ] ; then
count_num
chwrite "10000" /sys/module/adreno_idler/parameters/adreno_idler_idleworkload 
chwrite '40' /sys/module/adreno_idler/parameters/adreno_idler_downdifferential 
chwrite '24' /sys/module/adreno_idler/parameters/adreno_idler_idlewait 
echo "[LOG] Powersave 模式 adreno_idler 优化完毕." |  tee -a $LOG;
fi
fi
fi
if [ $mode = "gamexe" ] ; then
if [ -e $GPU_DIR/devfreq/adrenoboost ] ; then
count_num
chwrite "3" $GPU_DIR/devfreq/adrenoboost
echo "3" > /data/FastTurbo/SmartAI/adreno_boost
fi
if [ -e /sys/module/adreno_idler/parameters/adreno_idler_active ]; then
count_num
chwrite "0" /sys/module/adreno_idler/parameters/adreno_idler_active
fi
elif [ $mode = "turbo" ] ; then
if [ -e $GPU_DIR/devfreq/adrenoboost ] ; then
count_num
chwrite "2" $GPU_DIR/devfreq/adrenoboost
echo "2" > /data/FastTurbo/SmartAI/adreno_boost
fi
if [ -e /sys/module/adreno_idler/parameters/adreno_idler_active ]; then
count_num
chwrite "0" /sys/module/adreno_idler/parameters/adreno_idler_active
fi
elif [ $mode = "balance" ] ; then
if [ -e $GPU_DIR/devfreq/adrenoboost ] ; then
count_num
chwrite "1" $GPU_DIR/devfreq/adrenoboost
echo "1" > /data/FastTurbo/SmartAI/adreno_boost
fi
if [ -e /sys/module/adreno_idler/parameters/adreno_idler_active ]; then
count_num
chwrite "1" /sys/module/adreno_idler/parameters/adreno_idler_active
fi
elif [ $mode = "powersave" ] ; then
if [ -e $GPU_DIR/devfreq/adrenoboost ] ; then
count_num
chwrite "0" $GPU_DIR/devfreq/adrenoboost
echo "0" > /data/FastTurbo/SmartAI/adreno_boost
fi
if [ -e /sys/module/adreno_idler/parameters/adreno_idler_active ]; then
count_num
chwrite "1" /sys/module/adreno_idler/parameters/adreno_idler_active
fi
fi
echo "[LOG] $mode 模式 Adreno GPU 优化完毕." |  tee -a $LOG;
elif [ $GPU_SUB = "mali" ] ; then
#Mali GPU
if [ -d $GPU_DIR/devfreq/gpufreq/mali_ondemand/ ] ; then
count_num
if [ $mode = "gamexe" ] ; then
write 0 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync 
chmod 0000 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync 
chwrite 40 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_upthreshold 
echo "40" > /data/FastTurbo/SmartAI/mali_vsync_up 
chwrite 20 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_downdifferential 
echo "20" > /data/FastTurbo/SmartAI/mali_vsync_down 
chwrite 30 $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_upthreshold 
echo "30" > /data/FastTurbo/SmartAI/mali_novsync_up 
chwrite 10 $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_downdifferential 
echo "10" > /data/FastTurbo/SmartAI/mali_novsync_down 
echo "[LOG] $mode 模式 Mali GPU 优化完毕." |  tee -a $LOG;
elif [ $mode = "turbo" ] ; then
write 0 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync 
chmod 0000 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync 
chwrite 50 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_upthreshold 
echo "50" > /data/FastTurbo/SmartAI/mali_vsync_up 
chwrite 30 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_downdifferential 
echo "30" > /data/FastTurbo/SmartAI/mali_vsync_down 
chwrite 40 $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_upthreshold 
echo "40" > /data/FastTurbo/SmartAI/mali_novsync_up 
chwrite 20 $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_downdifferential 
echo "20" > /data/FastTurbo/SmartAI/mali_novsync_down 
echo "[LOG] $mode 模式 Mali GPU 优化完毕." |  tee -a $LOG;
elif [ $mode = "balance" ] ; then
chwrite 1 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync 
chwrite 70 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_upthreshold 
echo "70" > /data/FastTurbo/SmartAI/mali_vsync_up 
chwrite 50 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_downdifferential 
echo "50" > /data/FastTurbo/SmartAI/mali_vsync_down 
chwrite 60 $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_upthreshold 
echo "60" > /data/FastTurbo/SmartAI/mali_novsync_up 
chwrite 40 $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_downdifferential 
echo "40" > /data/FastTurbo/SmartAI/mali_novsync_down 
echo "[LOG] $mode 模式 Mali GPU 优化完毕." |  tee -a $LOG;
elif [ $mode = "powersave" ] ; then
chwrite 1 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync 
chwrite 90 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_upthreshold 
echo "90" > /data/FastTurbo/SmartAI/mali_vsync_up 
chwrite 70 $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_downdifferential 
echo "70" > /data/FastTurbo/SmartAI/mali_vsync_down 
chwrite 90 $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_upthreshold 
echo "90" > /data/FastTurbo/SmartAI/mali_novsync_up 
chwrite 70 $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_downdifferential 
echo "70" > /data/FastTurbo/SmartAI/mali_novsync_down
echo "[LOG] $mode 模式 Mali GPU 优化完毕." |  tee -a $LOG;
fi
fi
#启用Mali_Dvfs
if [ -e /proc/mali/dvfs_enable ] ; then
count_num
chwrite "1" /proc/mali/dvfs_enable
echo "[LOG] Mali Dvfs 已开启." |  tee -a $LOG;
fi
elif [ -e /proc/gpufreq/gpufreq_limited_thermal_ignore ] ; then
if [ $mode != "powersave" ] ; then
chwrite 1 "/proc/gpufreq/gpufreq_limited_thermal_ignore" 
chwrite 1 "/proc/gpufreq/gpufreq_limited_oc_ignore" 
chwrite 1 "/proc/gpufreq/gpufreq_limited_low_batt_volume_ignore" 
chwrite 1 "/proc/gpufreq/gpufreq_limited_low_batt_volt_ignore" 
else
chwrite 0 "/proc/gpufreq/gpufreq_limited_thermal_ignore" 
chwrite 0 "/proc/gpufreq/gpufreq_limited_oc_ignore" 
chwrite 0 "/proc/gpufreq/gpufreq_limited_low_batt_volume_ignore" 
chwrite 0 "/proc/gpufreq/gpufreq_limited_low_batt_volt_ignore" 
fi
echo "[LOG] MTK GPU 优化完毕." |  tee -a $LOG;
else
echo "[ERROR] GPU 优化不被支持." |  tee -a $LOG;
fi
#--------------------------------------------------------
#CPU优化-------------------------------------------------
if [ $mode = "turbo" ] ; then
if [ $use_eas = "true" ] ; then
GOV=`echo $EAS_GOVERNOR`
else
GOV="interactive"
fi
io_is_busy_on="1"
elif [ $mode = "balance" ] ; then
if [ $use_eas = "true" ] ; then
GOV=`echo $EAS_GOVERNOR`
else
GOV="interactive"
fi
io_is_busy_on="0"
elif [ $mode = "gamexe" ] ; then
if [ $use_eas = "true" ] ; then
GOV=`echo $EAS_GOVERNOR`
else
GOV="interactive"
fi
io_is_busy_on="1"
elif [ $mode = "powersave" ] ; then
if [ $use_eas = "true" ] ; then
GOV=`echo $EAS_GOVERNOR`
else
GOV="interactive"
fi
io_is_busy_on="0"
fi
echo "$GOV" > /data/FastTurbo/SmartAI/cpu_governor
if [ -e /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor ] ; then
count_num
if [ $core_num = "9" ] ; then
chwrite "$GOV" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu5/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu6/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu7/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu8/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu9/cpufreq/scaling_governor
elif [ $core_num = "7" ] ; then
chwrite "$GOV" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu5/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu6/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu7/cpufreq/scaling_governor 
elif [ $core_num = "5" ] ; then
chwrite "$GOV" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu5/cpufreq/scaling_governor 
elif [ $core_num = "3" ] ; then
chwrite "$GOV" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$GOV" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor
fi
echo "[LOG] 调频器已切换为 $GOV ." |  tee -a $LOG;
fi
if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/io_is_busy ] ; then
if [ $use_eas = "false" ] ; then
count_num
if [ $core_num = "9" ] ; then
#io_is_busy
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu0/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu1/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu2/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu3/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu4/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu5/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu6/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu7/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu8/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu9/cpufreq/$GOV/io_is_busy 
elif [ $core_num = "7" ] ; then
#io_is_busy
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu0/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu1/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu2/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu3/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu4/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu5/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu6/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu7/cpufreq/$GOV/io_is_busy 
elif [ $core_num = "5" ] ; then
#io_is_busy
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu0/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu1/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu2/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu3/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu4/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu5/cpufreq/$GOV/io_is_busy 
elif [ $core_num = "3" ] ; then
#io_is_busy
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu0/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu1/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu2/cpufreq/$GOV/io_is_busy 
chwrite $io_is_busy_on /sys/devices/system/cpu/cpu3/cpufreq/$GOV/io_is_busy 
fi
echo "[LOG] $mode 模式 io_is_busy 优化完毕." |  tee -a $LOG;
fi
fi
#适配骁龙200/400/600/80x等原始四核处理器
if [ -d /sys/devices/system/cpu/cpufreq/$GOV/ ] ; then
count_num
chwrite $io_is_busy_on /sys/devices/system/cpu/cpufreq/$GOV/io_is_busy
echo "[LOG] $mode 模式 io_is_busy 优化完毕." |  tee -a $LOG;
fi
#-----------------------------------------------------
#Virtual Memory 调整----------------------------------
if [ $vm_fix = "true" ] ; then
count_num
sysctl -e -w vm.overcommit_memory=1
sysctl -e -w vm.panic_on_oom=0
sysctl -e -w vm.oom_kill_allocating_task=0
sysctl -e -w vm.min_free_kbytes=32768
sysctl -e -w vm.dirty_background_ratio=10
sysctl -e -w vm.dirty_ratio=20
sysctl -e -w vm.swappiness=100
sysctl -e -w vm.page-cluster=4
sysctl -e -w vm.pagecache=10 30 95
sysctl -e -w vm.overcommit_ratio=80
sysctl -e -w vm.min_readahead=16
if [ $mode = "balance" ] ; then
sysctl -e -w vm.vfs_cache_pressure=150
sysctl -e -w vm.dirty_writeback_centisecs=600
sysctl -e -w vm.dirty_expire_centisecs=400
sysctl -e -w vm.max_readahead=20
echo "[LOG] $mode 模式 Virtual Memory 优化完毕." |  tee -a $LOG;
elif [ $mode = "powersave" ] ; then
sysctl -e -w vm.vfs_cache_pressure=150
sysctl -e -w vm.dirty_writeback_centisecs=500
sysctl -e -w vm.dirty_expire_centisecs=300
sysctl -e -w vm.max_readahead=16
echo "[LOG] $mode 模式 Virtual Memory 优化完毕." |  tee -a $LOG;
elif [ $mode = "gamexe" ] ; then
sysctl -e -w vm.vfs_cache_pressure=200
sysctl -e -w vm.dirty_writeback_centisecs=350
sysctl -e -w vm.dirty_expire_centisecs=200
sysctl -e -w vm.max_readahead=32
echo "[LOG] $mode 模式 Virtual Memory 优化完毕." |  tee -a $LOG;
elif [ $mode = "turbo" ] ; then
sysctl -e -w vm.vfs_cache_pressure=180
sysctl -e -w vm.dirty_writeback_centisecs=400
sysctl -e -w vm.dirty_expire_centisecs=250
sysctl -e -w vm.max_readahead=28
echo "[LOG] $mode 模式 Virtual Memory 优化完毕." |  tee -a $LOG;
fi
fi
#---------------------------------------------------------------
#I/O优化--------------------------------------------------------
if [ -e /sys/block/mmcblk0/queue/scheduler ] ; then
count_num
IO_mode="deadline"
if [ $io_fix = "true" ] ; then
MMC=$(ls -d /sys/block/mmc*)
DM=$(ls -d /sys/block/dm-*)
SD=$(ls -d /sys/block/sd*)
LOOP=$(ls -d /sys/block/loop*)
RAM=$(ls -d /sys/block/ram*)
if [ $mode = "powersave" ] ; then
KB=512
NR=128
READ_EXPIRE=500
WRITE_EXPIRE=5000
elif [ $mode = "balance" ] ; then
KB=1024
NR=128
READ_EXPIRE=400
WRITE_EXPIRE=4000
else
KB=2048
NR=256
READ_EXPIRE=300
WRITE_EXPIRE=3000
fi
for IO_DIR in $MMC $SD $DM $LOOP $RAM $ZR
do
 chwrite "$IO_mode" $IO_DIR/queue/scheduler 
 chwrite "$NR" $IO_DIR/queue/nr_requests 
 chwrite "$NR" $IO_DIR/queue/read_ahead_kb  
 chwrite "2" $IO_DIR/queue/iosched/fifo_batch 
 chwrite "3" $IO_DIR/queue/iosched/writes_starved  
 chwrite "$READ_EXPIRE" $IO_DIR/queue/iosched/read_expire  
 chwrite "$WRITE_EXPIRE" $IO_DIR/queue/iosched/write_expire  
 chwrite "$READ_EXPIRE" $IO_DIR/queue/iosched/sync_read_expire  
 chwrite "$WRITE_EXPIRE" $IO_DIR/queue/iosched/sync_write_expire  
 chwrite "$READ_EXPIRE" $IO_DIR/queue/iosched/async_read_expire 
 chwrite "$WRITE_EXPIRE" $IO_DIR/queue/iosched/async_write_expire 
done
if [ "`ls /sys/devices/virtual/bdi/179*/read_ahead_kb`" ]; then
 for RDAH_DIR in /sys/devices/virtual/bdi/179*/read_ahead_kb
do
 chwrite "$KB" $RDAH_DIR
done
fi;
echo "[LOG] I/O 性能优化完毕." |  tee -a $LOG;
fi
fi
#------------------------------------------------------------
#Low Power Levels 优化---------------------------------------
if [ $lpl_fix = "true" ] ; then
if [ -d /sys/module/lpm_levels/ ]; then
 count_num
 chwrite "2" /sys/module/lpm_levels/enable_low_power/l2 
 chwrite "1"  /sys/module/lpm_resources/enable_low_power/pxo  
 chwrite "1"  /sys/module/lpm_resources/enable_low_power/vdd_dig 
 chwrite "1"  /sys/module/lpm_resources/enable_low_power/vdd_mem 
 if [ $mode != "gamexe" ] ; then
 if [ -d /sys/module/lpm_levels/system/performence/cpu0/ ] ; then
 count_num
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu0/pc/idle-enabled  
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu0/pc/suspend_enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu0/ret/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu0/ret/suspend_enabled  
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu0/wfi/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu0/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/performence/cpu1/ ] ; then
 count_num
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu1/pc/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu1/pc/suspend_enabled  
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu1/ret/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu1/ret/suspend_enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu1/wfi/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu1/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/performence/cpu2/ ] ; then
 count_num
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu2/pc/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu2/pc/suspend_enabled  
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu2/ret/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu2/ret/suspend_enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu2/wfi/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu2/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/performence/cpu3/ ] ; then
 count_num
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu3/pc/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu3/pc/suspend_enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu3/ret/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu3/ret/suspend_enabled  
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu3/wfi/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/performence/cpu3/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/power/cpu4/ ] ; then
 count_num
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu4/pc/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu4/pc/suspend_enabled  
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu4/ret/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu4/ret/suspend_enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu4/wfi/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu4/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/power/cpu5/ ] ; then
 count_num
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu5/pc/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu5/pc/suspend_enabled  
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu5/ret/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu5/ret/suspend_enabled  
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu5/wfi/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu5/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/power/cpu6/ ] ; then
 count_num
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu6/pc/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu6/pc/suspend_enabled  
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu6/ret/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu6/ret/suspend_enabled  
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu6/wfi/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu6/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/power/cpu7/ ] ; then
 count_num
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu7/pc/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu7/pc/suspend_enabled  
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu7/ret/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu7/ret/suspend_enabled  
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu7/wfi/idle-enabled 
 chwrite "Y" /sys/module/lpm_levels/system/power/cpu7/wfi/suspend_enabled 
 fi
else
if [ -d /sys/module/lpm_levels/system/performence/cpu0/ ] ; then
 count_num
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu0/pc/idle-enabled  
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu0/pc/suspend_enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu0/ret/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu0/ret/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu0/wfi/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu0/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/performence/cpu1/ ] ; then
 count_num
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu1/pc/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu1/pc/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu1/ret/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu1/ret/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu1/wfi/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu1/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/performence/cpu2/ ] ; then
 count_num
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu2/pc/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu2/pc/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu2/ret/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu2/ret/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu2/wfi/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu2/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/performence/cpu3/ ] ; then
 count_num
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu3/pc/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu3/pc/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu3/ret/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu3/ret/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu3/wfi/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/performence/cpu3/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/power/cpu4/ ] ; then
 count_num
 chwrite "N" /sys/module/lpm_levels/system/power/cpu4/pc/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu4/pc/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/power/cpu4/ret/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu4/ret/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/power/cpu4/wfi/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu4/wfi/suspend_enabled  
 fi
 if [ -d /sys/module/lpm_levels/system/power/cpu5/ ] ; then
 count_num
 chwrite "N" /sys/module/lpm_levels/system/power/cpu5/pc/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu5/pc/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/power/cpu5/ret/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu5/ret/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/power/cpu5/wfi/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu5/wfi/suspend_enabled 
 fi
 if [ -d /sys/module/lpm_levels/system/power/cpu6/ ] ; then
 count_num
 chwrite "N" /sys/module/lpm_levels/system/power/cpu6/pc/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu6/pc/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/power/cpu6/ret/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu6/ret/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/power/cpu6/wfi/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu6/wfi/suspend_enabled  
 fi
 if [ -d /sys/module/lpm_levels/system/power/cpu7/ ] ; then
 count_num
 chwrite "N" /sys/module/lpm_levels/system/power/cpu7/pc/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu7/pc/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/power/cpu7/ret/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu7/ret/suspend_enabled  
 chwrite "N" /sys/module/lpm_levels/system/power/cpu7/wfi/idle-enabled 
 chwrite "N" /sys/module/lpm_levels/system/power/cpu7/wfi/suspend_enabled 
 fi
fi
echo "[LOG] Low Power Levels 优化完毕." | tee  -a $LOG;
fi
fi
#--------------------------------------------------------------
#CPUSET优化----------------------------------------------------
if [ -d /dev/cpuset/ ] ; then
#0=none ; 1=2big,6little ; 2=1big,7little ; 3=2big,2mid,4little ; 4=1big,3little ; 5=8mid (snapdragon625,450)
#/dev/cpuset/background/cpus           后台运行分配CPU核心
#/dev/cpuset/system-background/cpus    系统后台分配CPU核心
#/dev/cpuset/foreground/cpus           前台分配CPU核心
#/dev/cpuset/top-app/cpus              首选应用分配CPU核心
count_num
if [ $core_num = "9" ] ; then
chwrite "0-9" /dev/cpuset/cpus
 if [ ${freq0} -gt ${freq9} ] ; then
  chwrite "6-9" /dev/cpuset/background/cpus 
  echo "6-9" > /data/FastTurbo/SmartAI/background_cpus 
  chwrite "6-9" /dev/cpuset/system-background/cpus 
  echo "6-9" > /data/FastTurbo/SmartAI/sys_background_cpus 
  chwrite "0-5" /dev/cpuset/foreground/cpus 
  chwrite "0-5" /dev/cpuset/foreground/boost/cpus 
  echo "0-5" > /data/FastTurbo/SmartAI/foreground_cpus 
  chwrite "0-9" /dev/cpuset/top-app/cpus 
  chwrite "0-9" /dev/cpuset/top-app/boost/cpus 
  echo "0-9" > /data/FastTurbo/SmartAI/topapp_cpus 
  chwrite "0-9" /dev/cpuset/game/cpus 
  echo "0-9" > /data/FastTurbo/SmartAI/game_cpus
 else
  chwrite "0-3" /dev/cpuset/background/cpus 
  echo "0-3" > /data/FastTurbo/SmartAI/background_cpus 
  chwrite "0-3" /dev/cpuset/system-background/cpus 
  echo "0-3" > /data/FastTurbo/SmartAI/sys_background_cpus 
  chwrite "4-9" /dev/cpuset/foreground/cpus 
  chwrite "4-9" /dev/cpuset/foreground/boost/cpus 
  echo "4-9" > /data/FastTurbo/SmartAI/foreground_cpus 
  chwrite "0-9" /dev/cpuset/top-app/cpus 
  chwrite "0-9" /dev/cpuset/top-app/boost/cpus 
  echo "0-9" > /data/FastTurbo/SmartAI/topapp_cpus 
  chwrite "0-9" /dev/cpuset/game/cpus 
  echo "0-9" > /data/FastTurbo/SmartAI/game_cpus
 fi
elif [ $core_num = "7" ] ; then
chwrite "0-7" /dev/cpuset/cpus
 if [ $soc_special = "0" ] ; then
  if [ ${freq0} -gt ${freq7} ] ; then
   chwrite "4-7" /dev/cpuset/background/cpus 
   echo "4-7" > /data/FastTurbo/SmartAI/background_cpus 
   chwrite "4-7" /dev/cpuset/system-background/cpus 
   echo "4-7" > /data/FastTurbo/SmartAI/sys_background_cpus 
   chwrite "0-3" /dev/cpuset/foreground/cpus 
   chwrite "0-3" /dev/cpuset/foreground/boost/cpus 
   echo "0-3" > /data/FastTurbo/SmartAI/foreground_cpus 
   chwrite "0-7" /dev/cpuset/top-app/cpus 
   chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/topapp_cpus 
   chwrite "0-7" /dev/cpuset/game/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/game_cpus 
  else
   chwrite "0-3" /dev/cpuset/background/cpus 
   echo "0-3" > /data/FastTurbo/SmartAI/background_cpus 
   chwrite "0-3" /dev/cpuset/system-background/cpus 
   echo "0-3" > /data/FastTurbo/SmartAI/sys_background_cpus 
   chwrite "4-7" /dev/cpuset/foreground/cpus 
   chwrite "4-7" /dev/cpuset/foreground/boost/cpus 
   echo "4-7" > /data/FastTurbo/SmartAI/foreground_cpus 
   chwrite "0-7" /dev/cpuset/top-app/cpus 
   chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/topapp_cpus 
   chwrite "0-7" /dev/cpuset/game/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/game_cpus
  fi
 elif [ $soc_special = "1" ] ; then
  if [ ${freq0} -gt ${freq7} ] ; then
   chwrite "2-7" /dev/cpuset/background/cpus 
   echo "2-7" > /data/FastTurbo/SmartAI/background_cpus 
   chwrite "2-7" /dev/cpuset/system-background/cpus 
   echo "2-7" > /data/FastTurbo/SmartAI/sys_background_cpus 
   chwrite "0-1" /dev/cpuset/foreground/cpus 
   chwrite "0-1" /dev/cpuset/foreground/boost/cpus 
   echo "0-1" > /data/FastTurbo/SmartAI/foreground_cpus 
   chwrite "0-7" /dev/cpuset/top-app/cpus 
   chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/topapp_cpus 
   chwrite "0-7" /dev/cpuset/game/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/game_cpus
  else
   chwrite "0-5" /dev/cpuset/background/cpus 
   echo "0-5" > /data/FastTurbo/SmartAI/background_cpus 
   chwrite "0-5" /dev/cpuset/system-background/cpus 
   echo "0-5" > /data/FastTurbo/SmartAI/sys_background_cpus 
   chwrite "6-7" /dev/cpuset/foreground/cpus 
   chwrite "6-7" /dev/cpuset/foreground/boost/cpus 
   echo "6-7" > /data/FastTurbo/SmartAI/foreground_cpus 
   chwrite "0-7" /dev/cpuset/top-app/cpus 
   chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/topapp_cpus 
   chwrite "0-7" /dev/cpuset/game/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/game_cpus
  fi
 elif [ $soc_special = "3" ] ; then
  if [ ${freq0} -gt ${freq7} ] ; then
   chwrite "4-7" /dev/cpuset/background/cpus 
   echo "4-7" > /data/FastTurbo/SmartAI/background_cpus 
   chwrite "4-7" /dev/cpuset/system-background/cpus 
   echo "4-7" > /data/FastTurbo/SmartAI/sys_background_cpus 
   chwrite "0-3" /dev/cpuset/foreground/cpus 
   chwrite "0-3" /dev/cpuset/foreground/boost/cpus 
   echo "0-3" > /data/FastTurbo/SmartAI/foreground_cpus 
   chwrite "0-7" /dev/cpuset/top-app/cpus 
   chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/topapp_cpus 
   chwrite "0-7" /dev/cpuset/game/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/game_cpus
  else
   chwrite "0-3" /dev/cpuset/background/cpus 
   echo "0-3" > /data/FastTurbo/SmartAI/background_cpus 
   chwrite "0-3" /dev/cpuset/system-background/cpus 
   echo "0-3" > /data/FastTurbo/SmartAI/sys_background_cpus 
   chwrite "4-7" /dev/cpuset/foreground/cpus 
   chwrite "4-7" /dev/cpuset/foreground/boost/cpus 
   echo "4-7" > /data/FastTurbo/SmartAI/foreground_cpus 
   chwrite "0-7" /dev/cpuset/top-app/cpus 
   chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/topapp_cpus 
   chwrite "0-7" /dev/cpuset/game/cpus 
   echo "0-7" > /data/FastTurbo/SmartAI/game_cpus
  fi
 elif [ $soc_special = "5" ] ; then
  chwrite "0-1" /dev/cpuset/background/cpus 
  echo "0-1" > /data/FastTurbo/SmartAI/background_cpus 
  chwrite "0-1" /dev/cpuset/system-background/cpus 
  echo "0-1" > /data/FastTurbo/SmartAI/sys_background_cpus 
  chwrite "0-7" /dev/cpuset/foreground/cpus 
  chwrite "0-7" /dev/cpuset/foreground/boost/cpus 
  echo "0-7" > /data/FastTurbo/SmartAI/foreground_cpus 
  chwrite "0-7" /dev/cpuset/top-app/cpus 
  chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
  echo "0-7" > /data/FastTurbo/SmartAI/topapp_cpus 
  chwrite "0-7" /dev/cpuset/game/cpus 
  echo "0-7" > /data/FastTurbo/SmartAI/game_cpus
 fi
elif [ $core_num = "5" ] ; then
chwrite "0-5" /dev/cpuset/cpus
 if [ ${freq0} -gt ${freq5} ] ; then
  chwrite "2-5" /dev/cpuset/background/cpus 
  echo "2-5" > /data/FastTurbo/SmartAI/background_cpus 
  chwrite "2-5" /dev/cpuset/system-background/cpus 
  echo "2-5" > /data/FastTurbo/SmartAI/sys_background_cpus 
  chwrite "0-1" /dev/cpuset/foreground/cpus 
  chwrite "0-1" /dev/cpuset/foreground/boost/cpus 
  echo "0-1" > /data/FastTurbo/SmartAI/foreground_cpus 
  chwrite "0-5" /dev/cpuset/top-app/cpus 
  chwrite "0-5" /dev/cpuset/top-app/boost/cpus 
  echo "0-5" > /data/FastTurbo/SmartAI/topapp_cpus 
  chwrite "0-5" /dev/cpuset/game/cpus 
  echo "0-5" > /data/FastTurbo/SmartAI/game_cpus
 else
  chwrite "0-3" /dev/cpuset/background/cpus 
  echo "0-3" > /data/FastTurbo/SmartAI/background_cpus 
  chwrite "0-3" /dev/cpuset/system-background/cpus 
  echo "0-3" > /data/FastTurbo/SmartAI/sys_background_cpus 
  chwrite "4-5" /dev/cpuset/foreground/cpus 
  chwrite "4-5" /dev/cpuset/foreground/boost/cpus 
  echo "4-5" > /data/FastTurbo/SmartAI/foreground_cpus 
  chwrite "0-5" /dev/cpuset/top-app/cpus 
  chwrite "0-5" /dev/cpuset/top-app/boost/cpus 
  echo "0-5" > /data/FastTurbo/SmartAI/topapp_cpus 
  chwrite "0-5" /dev/cpuset/game/cpus 
  echo "0-5" > /data/FastTurbo/SmartAI/game_cpus
 fi
elif [ $core_num = "3" ] ; then
chwrite "0-3" /dev/cpuset/cpus
 if [ $SOC = "msm8996" ] ; then
  if [ ${freq0} -gt ${freq3} ] ; then
   chwrite "2-3" /dev/cpuset/background/cpus 
   echo "2-3" > /data/FastTurbo/SmartAI/background_cpus 
   chwrite "2-3" /dev/cpuset/system-background/cpus 
   echo "2-3" > /data/FastTurbo/SmartAI/sys_background_cpus 
   chwrite "0-1" /dev/cpuset/foreground/cpus 
   chwrite "0-1" /dev/cpuset/foreground/boost/cpus 
   echo "0-1" > /data/FastTurbo/SmartAI/foreground_cpus 
   chwrite "0-3" /dev/cpuset/top-app/cpus 
   chwrite "0-3" /dev/cpuset/top-app/boost/cpus 
   echo "0-3" > /data/FastTurbo/SmartAI/topapp_cpus 
   chwrite "0-3" /dev/cpuset/game/cpus 
   echo "0-3" > /data/FastTurbo/SmartAI/game_cpus
  else
   chwrite "0-1" /dev/cpuset/background/cpus 
   echo "0-1" > /data/FastTurbo/SmartAI/background_cpus 
   chwrite "0-1" /dev/cpuset/system-background/cpus 
   echo "0-1" > /data/FastTurbo/SmartAI/sys_background_cpus 
   chwrite "2-3" /dev/cpuset/foreground/cpus 
   chwrite "2-3" /dev/cpuset/foreground/boost/cpus 
   echo "2-3" > /data/FastTurbo/SmartAI/foreground_cpus 
   chwrite "0-3" /dev/cpuset/top-app/cpus 
   chwrite "0-3" /dev/cpuset/top-app/boost/cpus 
   echo "0-3" > /data/FastTurbo/SmartAI/topapp_cpus 
   chwrite "0-3" /dev/cpuset/game/cpus 
   echo "0-3" > /data/FastTurbo/SmartAI/game_cpus
  fi
 else
 chwrite "0" /dev/cpuset/background/cpus 
 echo "0" > /data/FastTurbo/SmartAI/background_cpus 
 chwrite "0" /dev/cpuset/system-background/cpus 
 echo "0" > /data/FastTurbo/SmartAI/sys_background_cpus 
 chwrite "0-3" /dev/cpuset/foreground/cpus 
 chwrite "0-3" /dev/cpuset/foreground/boost/cpus 
 echo "0-3" > /data/FastTurbo/SmartAI/foreground_cpus 
 chwrite "0-3" /dev/cpuset/top-app/cpus 
 chwrite "0-3" /dev/cpuset/top-app/boost/cpus 
 echo "0-3" > /data/FastTurbo/SmartAI/topapp_cpus 
 chwrite "0-3" /dev/cpuset/game/cpus 
 echo "0-3" > /data/FastTurbo/SmartAI/game_cpus
 fi
fi
echo "[LOG] CPUSET 优化完毕." | tee  -a $LOG;
fi
#-----------------------------------------------------------
#大核负载优先---------------------------------------------
if [ $mode != "powersave" ] ; then
cpu_fz="0"
if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
chwrite "10" /proc/sys/kernel/sched_spill_nr_run
fi
if [ -e /proc/sys/kernel/sched_spill_load ] ; then
chwrite "85" /proc/sys/kernel/sched_spill_load
fi
echo "[LOG] $mode 模式 CPU核心负载策略 优化完毕." | tee  -a $LOG;
else
if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
chwrite "3" /proc/sys/kernel/sched_spill_nr_run
fi
if [ -e /proc/sys/kernel/sched_spill_load ] ; then
chwrite "60" /proc/sys/kernel/sched_spill_load
fi
echo "[LOG] $mode 模式 CPU核心负载策略 优化完毕." | tee  -a $LOG;
fi
#---------------------------------------------------------
#Powersave模式降低主频------------------------------------
MTK="false"
case $SOC in mt*)
MTK="true"
esac
if [ -e /data/FastTurbo/jp_function ] ; then
 JP_SUPPORT=$(cat /data/FastTurbo/jp_function)
else
 echo "support" > /data/FastTurbo/jp_function
 JP_SUPPORT="support"
fi
if [ $mode = "powersave" ] ; then
if [ $JP_SUPPORT = "support" ] ; then
echo "true" > /data/FastTurbo/now_jp
if [ $core_num = "7" ] ; then
if [ $soc_special = "0" ] ; then
if [ ${freq0} -gt ${freq4} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_2}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq
echo "cpu4" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $soc_special = "1" ] ; then
#2big,6little
if [ ${freq0} -gt ${freq7} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_4}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq
echo "cpu6" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $soc_special = "3" ] ; then
#1big,3mid,4little
if [ ${freq0} -gt ${freq7} ] ; then
freq_max_length=`echo ${#available_freq_a}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq
echo "cpu1" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_4}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_4:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_4:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq
echo "cpu4" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $soc_special = "5" ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $core_num = "9" ] ; then
if [ ${freq0} -gt ${freq9} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_3}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_3:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_3:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_3:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_3:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_3:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_3:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu8/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu9/cpufreq/scaling_max_freq
echo "cpu8" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $core_num = "5" ] ; then
if [ ${freq0} -gt ${freq5} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_2}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_2:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_2:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq
echo "cpu4" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
elif [ $core_num = "3" ] ; then
if [ $soc_special = "0" ] ; then
if [ $SOC = "msm8996" ] ; then
if [ ${freq0} -gt ${freq3} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
else
freq_max_length=`echo ${#available_freq_a}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_a:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_a:16:7}`
fi
fi
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq
echo "cpu2" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
else
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 120 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-56:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:56:7}`
fi
elif [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-40:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:40:7}`
fi
else
if [ $MTK != "true" ] ; then
pwrsv_freq_max=`echo ${available_freq_1:0-16:7}`
else
pwrsv_freq_max=`echo ${available_freq_1:16:7}`
fi
fi 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq 
chwrite $pwrsv_freq_max /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq 
echo "cpu0" > /data/FastTurbo/SmartAI/pwrsv_check
echo "$pwrsv_freq_max" > /data/FastTurbo/SmartAI/pwrsv_freq
fi
fi
fi
echo "[LOG] PowerSave 模式主频调整为 $(($pwrsv_freq_max/1000)) MHz." |  tee -a $LOG;
else
if [ $core_num = "9" ] ; then
  if [ ${freq0} -gt ${freq9} ] ; then
   chwrite "0" "/sys/devices/system/cpu/cpu0/online" 
   echo "0" > /data/FastTurbo/SmartAI/cpu0_online 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   echo "0" > /data/FastTurbo/SmartAI/cpu1_online 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu3_online 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu4_online 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu5_online 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu6_online 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu7_online 
   chwrite "1" "/sys/devices/system/cpu/cpu8/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu8_online 
   chwrite "1" "/sys/devices/system/cpu/cpu9/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu9_online
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu3_online 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu4_online 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu5_online 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu6_online 
   chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu7_online 
   chwrite "0" "/sys/devices/system/cpu/cpu8/online" 
   echo "0" > /data/FastTurbo/SmartAI/cpu8_online 
   chwrite "0" "/sys/devices/system/cpu/cpu9/online" 
   echo "0" > /data/FastTurbo/SmartAI/cpu9_online
  fi
 elif [ $core_num = "7" ] ; then
  if [ $soc_special = "0" -o $soc_special = "3" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu3_online 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu4_online 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu5_online 
    chwrite "0" "/sys/devices/system/cpu/cpu6/online" 
	echo "0" > /data/FastTurbo/SmartAI/cpu6_online 
    chwrite "0" "/sys/devices/system/cpu/cpu7/online" 
	echo "0" > /data/FastTurbo/SmartAI/cpu7_online 
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
	echo "0" > /data/FastTurbo/SmartAI/cpu2_online 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
	echo "0" > /data/FastTurbo/SmartAI/cpu3_online 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu4_online 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu5_online 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu6_online 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu7_online
   fi
  elif [ $soc_special = "1" ] ; then
   if [ ${freq0} -gt ${freq7} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
    chwrite "0" "/sys/devices/system/cpu/cpu2/online" 
	echo "0" > /data/FastTurbo/SmartAI/cpu2_online 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
	echo "0" > /data/FastTurbo/SmartAI/cpu3_online 
    chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu4_online 
    chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu5_online 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu6_online 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu7_online
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
 	echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu3_online 
    chwrite "0" "/sys/devices/system/cpu/cpu4/online" 
	echo "0" > /data/FastTurbo/SmartAI/cpu4_online 
    chwrite "0" "/sys/devices/system/cpu/cpu5/online" 
	echo "0" > /data/FastTurbo/SmartAI/cpu5_online 
    chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu6_online 
    chwrite "1" "/sys/devices/system/cpu/cpu7/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu7_online
   fi
  elif [ $soc_special = "5" ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu3_online 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu4_online 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu5_online 
   chwrite "1" "/sys/devices/system/cpu/cpu6/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu6_online 
   chwrite "0" "/sys/devices/system/cpu/cpu7/online" 
   echo "0" > /data/FastTurbo/SmartAI/cpu7_online
  fi
 elif [ $core_num = "5" ] ; then
  if [ ${freq0} -gt ${freq5} ] ; then
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
   chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
   echo "0" > /data/FastTurbo/SmartAI/cpu1_online 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu3_online 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu4_online 
   chwrite "1" "/sys/devices/system/cpu/cpu5/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu5_online
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
   chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu3_online 
   chwrite "1" "/sys/devices/system/cpu/cpu4/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu4_online 
   chwrite "0" "/sys/devices/system/cpu/cpu5/online" 
   echo "0" > /data/FastTurbo/SmartAI/cpu5_online
  fi
 elif [ $core_num = "3" ] ; then
  if [ $SOC = "msm8996" ] ; then
   if [ ${freq0} -gt ${freq3} ] ; then
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
    chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
    chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
	echo "0" > /data/FastTurbo/SmartAI/cpu3_online 
   else
    chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
    chwrite "0" "/sys/devices/system/cpu/cpu1/online" 
	echo "0" > /data/FastTurbo/SmartAI/cpu1_online 
    chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
    chwrite "1" "/sys/devices/system/cpu/cpu3/online" 
	echo "1" > /data/FastTurbo/SmartAI/cpu3_online
   fi
  else
   chwrite "1" "/sys/devices/system/cpu/cpu0/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu0_online 
   chwrite "1" "/sys/devices/system/cpu/cpu1/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu1_online 
   chwrite "1" "/sys/devices/system/cpu/cpu2/online" 
   echo "1" > /data/FastTurbo/SmartAI/cpu2_online 
   chwrite "0" "/sys/devices/system/cpu/cpu3/online" 
   echo "0" > /data/FastTurbo/SmartAI/cpu3_online
  fi
 fi
 echo "[LOG] PowerSave 模式已关闭部分核心." |  tee -a $LOG;
fi
fi
#---------------------------------------------------------
#Set CPU SPEED--------------------------------------------
if [ $mode != "powersave" ] ; then
count_num
echo "false" > /data/FastTurbo/now_jp
if [ $core_num = "9" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
chwrite $freq4 "/sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq"
chwrite $freq5 "/sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq"
chwrite $freq6 "/sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq"
chwrite $freq7 "/sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq"
chwrite $freq8 "/sys/devices/system/cpu/cpu8/cpufreq/scaling_max_freq"
chwrite $freq9 "/sys/devices/system/cpu/cpu9/cpufreq/scaling_max_freq"
elif [ $core_num = "7" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
chwrite $freq4 "/sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq"
chwrite $freq5 "/sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq"
chwrite $freq6 "/sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq"
chwrite $freq7 "/sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq"
elif [ $core_num = "5" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
chwrite $freq4 "/sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq"
chwrite $freq5 "/sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq"
elif [ $core_num = "3" ] ; then
chwrite $freq0 "/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
chwrite $freq1 "/sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq"
chwrite $freq2 "/sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq"
chwrite $freq3 "/sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq"
fi
echo "[LOG] $mode 模式已调整到最高频率." |  tee -a $LOG;
fi
#---------------------------------------------------------
#EAS优化--------------------------------------------------
if [ $use_eas = "true" ] ; then
if [ -d /dev/stune/ ] ; then
count_num
chwrite "0" "/dev/stune/schedtune.boost" 
chwrite "1" "/dev/stune/schedtune.prefer_idle" 
chwrite "0" "/dev/stune/cgroup.clone_children" 
chwrite "0" "/dev/stune/cgroup.sane_behavior" 
chwrite "0" "/dev/stune/notify_on_release" 
chwrite "0" "/dev/stune/top-app/schedtune.sched_boost"  
chwrite "0" "/dev/stune/top-app/notify_on_release" 
chwrite "0" "/dev/stune/top-app/cgroup.clone_children" 
chwrite "0" "/dev/stune/foreground/schedtune.sched_boost"  
chwrite "0" "/dev/stune/foreground/notify_on_release" 
chwrite "0" "/dev/stune/foreground/cgroup.clone_children"  
chwrite "0" "/dev/stune/background/schedtune.sched_boost" 
chwrite "0" "/dev/stune/background/notify_on_release" 
chwrite "0" "/dev/stune/background/cgroup.clone_children"  
chwrite "1" "/dev/stune/schedtune.prefer_idle" 
chwrite "1" "/dev/stune/top-app/schedtune.prefer_idle" 
chwrite "1" "/dev/stune/foreground/schedtune.prefer_idle" 
chwrite "0" "/dev/stune/background/schedtune.prefer_idle" 
chwrite "0" "/dev/stune/rt/schedtune.prefer_idle" 
chwrite "10" "/dev/stune/rt/schedtune.boost"
if [ $soc_type = "mid" ] ; then
count_num
if [ $mode = "powersave" ];then
chwrite "0" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "0" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "0" /dev/stune/top-app/schedtune.boost 
echo "0" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "0" /dev/stune/foreground/schedtune.boost 
echo "0" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-40" /dev/stune/background/schedtune.boost 
echo "-40" > /data/FastTurbo/SmartAI/background_boost
elif [ $mode = "balance" ]; then
chwrite "0" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "0" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "5" /dev/stune/top-app/schedtune.boost 
echo "5" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "0" /dev/stune/foreground/schedtune.boost 
echo "0" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-30" /dev/stune/background/schedtune.boost 
echo "-30" > /data/FastTurbo/SmartAI/background_boost
elif [ $mode = "turbo" ]; then
chwrite "15" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "15" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "20" /dev/stune/top-app/schedtune.boost 
echo "20" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "15" /dev/stune/foreground/schedtune.boost 
echo "15" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-20" /dev/stune/background/schedtune.boost 
echo "-20" > /data/FastTurbo/SmartAI/background_boost
elif [ $mode = "gamexe" ]; then
chwrite "15" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "15" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "25" /dev/stune/top-app/schedtune.boost 
echo "25" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "20" /dev/stune/foreground/schedtune.boost 
echo "20" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-20" /dev/stune/background/schedtune.boost 
echo "-20" > /data/FastTurbo/SmartAI/background_boost
fi
elif [ $soc_type = "high" ] ; then
count_num
if [ $mode = "powersave" ];then
chwrite "0" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "0" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "0" /dev/stune/top-app/schedtune.boost 
echo "0" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "0" /dev/stune/foreground/schedtune.boost 
echo "0" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-50" /dev/stune/background/schedtune.boost 
echo "-50" > /data/FastTurbo/SmartAI/background_boost
elif [ $mode = "balance" ]; then
chwrite "0" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "0" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "0" /dev/stune/top-app/schedtune.boost 
echo "0" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "0" /dev/stune/foreground/schedtune.boost 
echo "0" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-30" /dev/stune/background/schedtune.boost 
echo "-30" > /data/FastTurbo/SmartAI/background_boost
elif [ $mode = "turbo" ]; then
chwrite "10" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "10" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "15" /dev/stune/top-app/schedtune.boost 
echo "15" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "10" /dev/stune/foreground/schedtune.boost 
echo "10" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-20" /dev/stune/background/schedtune.boost 
echo "-20" > /data/FastTurbo/SmartAI/background_boost
elif [ $mode = "gamexe" ]; then
chwrite "15" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "15" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "20" /dev/stune/top-app/schedtune.boost 
echo "20" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "15" /dev/stune/foreground/schedtune.boost 
echo "15" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-20" /dev/stune/background/schedtune.boost 
echo "-20" > /data/FastTurbo/SmartAI/background_boost 
fi
elif [ $soc_type = "low" ] ; then
count_num
if [ $mode = "powersave" ];then
chwrite "0" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "0" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "0" /dev/stune/top-app/schedtune.boost 
echo "0" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "0" /dev/stune/foreground/schedtune.boost 
echo "0" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-30" /dev/stune/background/schedtune.boost 
echo "-30" > /data/FastTurbo/SmartAI/background_boost 
elif [ $mode = "balance" ]; then
chwrite "5" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "5" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "10" /dev/stune/top-app/schedtune.boost 
echo "10" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "5" /dev/stune/foreground/schedtune.boost 
echo "5" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-20" /dev/stune/background/schedtune.boost 
echo "-20" > /data/FastTurbo/SmartAI/background_boost
elif [ $mode = "turbo" ]; then
chwrite "20" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "20" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "30" /dev/stune/top-app/schedtune.boost 
echo "30" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "25" /dev/stune/foreground/schedtune.boost 
echo "25" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-10" /dev/stune/background/schedtune.boost 
echo "-10" > /data/FastTurbo/SmartAI/foreground_boost
elif [ $mode = "gamexe" ]; then
chwrite "25" /sys/module/cpu_boost/parameters/dynamic_stune_boost 
echo "25" > /data/FastTurbo/SmartAI/dynamic_boost 
chwrite "35" /dev/stune/top-app/schedtune.boost 
echo "35" > /data/FastTurbo/SmartAI/topapp_boost 
chwrite "30" /dev/stune/foreground/schedtune.boost 
echo "30" > /data/FastTurbo/SmartAI/foreground_boost 
chwrite "-10" /dev/stune/background/schedtune.boost 
echo "-10" > /data/FastTurbo/SmartAI/foreground_boost 
fi
fi
fi
echo "[LOG] $mode 模式 Energy Aware Scheduling 优化完毕." | tee  -a $LOG;
fi
#------------------------------------------------------
#HMP优化-----------------------------------------------
if [ $GOV = "interactive" ] ; then
if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/use_sched_load ] ; then
count_num
 if [ $core_num = "9" ] ; then
 chwrite "1" /sys/devices/system/cpu/cpu0/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu1/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu2/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu3/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu4/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu5/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu6/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu7/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu8/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu9/cpufreq/$GOV/use_sched_load 
 elif [ $core_num = "7" ] ; then
 chwrite "1" /sys/devices/system/cpu/cpu0/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu1/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu2/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu3/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu4/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu5/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu6/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu7/cpufreq/$GOV/use_sched_load
 elif [ $core_num = "5" ] ; then
 chwrite "1" /sys/devices/system/cpu/cpu0/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu1/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu2/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu3/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu4/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu5/cpufreq/$GOV/use_sched_load 
 elif [ $core_num = "3" ] ; then
 chwrite "1" /sys/devices/system/cpu/cpu0/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu1/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu2/cpufreq/$GOV/use_sched_load 
 chwrite "1" /sys/devices/system/cpu/cpu3/cpufreq/$GOV/use_sched_load
 fi
 fi
if [ $use_smart_freq = "1" ] ; then
if [ $mode != "powersave" -o $JP_SUPPORT = "unsupport" ] ; then
count_num
if [ $core_num = "7" ] ; then
if [ $soc_special = "0" ] ; then
if [ ${freq0} -gt ${freq4} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-32:7}`
else
hispeed_freq=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-16:7}`
else
hispeed_freq=`echo ${available_freq_1:16:7}`
fi
fi
else
freq_max_length=`echo ${#available_freq_2}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_2:0-32:7}`
else
hispeed_freq=`echo ${available_freq_2:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_2:0-16:7}`
else
hispeed_freq=`echo ${available_freq_2:16:7}`
fi
fi
fi
elif [ $soc_special = "1" ] ; then
#2big,6little
if [ ${freq0} -gt ${freq7} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-32:7}`
else
hispeed_freq=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-16:7}`
else
hispeed_freq=`echo ${available_freq_1:16:7}`
fi
fi
else
freq_max_length=`echo ${#available_freq_4}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_4:0-32:7}`
else
hispeed_freq=`echo ${available_freq_4:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_4:0-16:7}`
else
hispeed_freq=`echo ${available_freq_4:16:7}`
fi
fi
fi
elif [ $soc_special = "3" ] ; then
#1big,3mid,4little
if [ ${freq0} -gt ${freq7} ] ; then
freq_max_length=`echo ${#available_freq_a}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_a:0-32:7}`
else
hispeed_freq=`echo ${available_freq_a:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_a:0-16:7}`
else
hispeed_freq=`echo ${available_freq_a:16:7}`
fi
fi
else
freq_max_length=`echo ${#available_freq_4}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_4:0-32:7}`
else
hispeed_freq=`echo ${available_freq_4:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_4:0-16:7}`
else
hispeed_freq=`echo ${available_freq_4:16:7}`
fi
fi
fi
elif [ $soc_special = "5" ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-32:7}`
else
hispeed_freq=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-16:7}`
else
hispeed_freq=`echo ${available_freq_1:16:7}`
fi
fi
fi
elif [ $core_num = "9" ] ; then
if [ ${freq0} -gt ${freq9} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-32:7}`
else
hispeed_freq=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-16:7}`
else
hispeed_freq=`echo ${available_freq_1:16:7}`
fi
fi
else
freq_max_length=`echo ${#available_freq_3}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_3:0-32:7}`
else
hispeed_freq=`echo ${available_freq_3:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_3:0-16:7}`
else
hispeed_freq=`echo ${available_freq_3:16:7}`
fi
fi
fi
elif [ $core_num = "5" ] ; then
if [ ${freq0} -gt ${freq5} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-32:7}`
else
hispeed_freq=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-16:7}`
else
hispeed_freq=`echo ${available_freq_1:16:7}`
fi
fi
else
freq_max_length=`echo ${#available_freq_2}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_2:0-32:7}`
else
hispeed_freq=`echo ${available_freq_2:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_2:0-16:7}`
else
hispeed_freq=`echo ${available_freq_2:16:7}`
fi
fi
fi
elif [ $core_num = "3" ] ; then
if [ $soc_special = "0" ] ; then
if [ $SOC = "msm8996" ] ; then
if [ ${freq0} -gt ${freq3} ] ; then
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-32:7}`
else
hispeed_freq=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-16:7}`
else
hispeed_freq=`echo ${available_freq_1:16:7}`
fi
fi
else
freq_max_length=`echo ${#available_freq_a}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_a:0-32:7}`
else
hispeed_freq=`echo ${available_freq_a:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_a:0-16:7}`
else
hispeed_freq=`echo ${available_freq_a:16:7}`
fi
fi
fi
else
freq_max_length=`echo ${#available_freq_1}`
if [ ${freq_max_length} -gt 80 ] ; then 
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-32:7}`
else
hispeed_freq=`echo ${available_freq_1:32:7}`
fi
else
if [ $MTK != "true" ] ; then
hispeed_freq=`echo ${available_freq_1:0-16:7}`
else
hispeed_freq=`echo ${available_freq_1:16:7}`
fi
fi 
fi
fi
fi
else
hispeed_freq=$(echo $pwrsv_freq)
fi
else
 hispeed_freq="null"
 echo "[WARNING] CPU频率数据获取失败,部分优化将无法执行 ." |  tee -a $LOG;
fi
 if [ $soc_type = "low" ] ; then
  if [ $mode = "gamexe" ] ; then
   min_delay_time="20000"
   high_delay_time="40000"
   s_high_delay_time="20000"
   hispeed_load="60"
   s_hispeed_load="70"
  elif [ $mode = "turbo" ] ; then
   min_delay_time="20000"
   high_delay_time="30000"
   s_high_delay_time="20000"
   hispeed_load="70"
   s_hispeed_load="80"
  else
   min_delay_time="20000"
   high_delay_time="30000"
   s_high_delay_time="20000"
   hispeed_load="80"
   s_hispeed_load="90"
  fi
 elif [ $soc_type = "mid" ] ; then
  if [ $mode = "gamexe" ] ; then
   min_delay_time="20000"
   high_delay_time="30000"
   s_high_delay_time="20000"
   hispeed_load="80"
   s_hispeed_load="90"
  elif [ $mode = "turbo" ] ; then
   min_delay_time="20000"
   high_delay_time="30000"
   s_high_delay_time="20000"
   hispeed_load="90"
   s_hispeed_load="99"
  else
   min_delay_time="20000"
   high_delay_time="20000"
   s_high_delay_time="20000"
   hispeed_load="99"
   s_hispeed_load="99"
  fi
 elif [ $soc_type = "high" ] ; then
  if [ $mode = "gamexe" ] ; then
   min_delay_time="20000"
   high_delay_time="20000"
   s_high_delay_time="20000"
   hispeed_load="90"
   s_hispeed_load="99"
  elif [ $mode = "turbo" ] ; then
   min_delay_time="20000"
   high_delay_time="20000"
   s_high_delay_time="20000"
   hispeed_load="95"
   s_hispeed_load="99"
  else
   min_delay_time="20000"
   high_delay_time="20000"
   s_high_delay_time="20000"
   hispeed_load="99"
   s_hispeed_load="99"
  fi
 fi
 if [ $core_num = "9" ] ; then
  if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/timer_rate ] ; then
  count_num
  chwrite $min_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu4/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu5/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu6/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu7/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu8/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu9/cpufreq/$GOV/timer_rate
  fi
  if [ ${freq0} -gt ${freq9} ] ; then
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load ] ; then
   count_num
   chwrite $hispeed_load /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu1/cpufreq/$GOV/go_hispeed_load
   if [ $hispeed_freq != "null" ] ; then
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu0/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu1/cpufreq/$GOV/hispeed_freq
   fi
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu2/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu3/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu4/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu5/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu6/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu7/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu8/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu9/cpufreq/$GOV/go_hispeed_load
   fi
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay ] ; then
   count_num
   chwrite $high_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu4/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu5/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu6/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu7/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu8/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu9/cpufreq/$GOV/above_hispeed_delay
   fi
  else
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load ] ; then
   count_num
   chwrite $hispeed_load /sys/devices/system/cpu/cpu8/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu9/cpufreq/$GOV/go_hispeed_load 
   if [ $hispeed_freq != "null" ] ; then
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu8/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu9/cpufreq/$GOV/hispeed_freq 
   fi
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu1/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu2/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu3/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu4/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu5/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu6/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu7/cpufreq/$GOV/go_hispeed_load
   fi
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay ] ; then
   count_num
   chwrite $high_delay_time /sys/devices/system/cpu/cpu9/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu8/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu7/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu6/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu5/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu4/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay
   fi
  fi
 elif [ $core_num = "7" ] ; then
  if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/timer_rate ] ; then
  count_num
  chwrite $min_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu4/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu5/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu6/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu7/cpufreq/$GOV/timer_rate
  fi
  if [ $soc_special = "0" ] ; then
  if [ ${freq0} -gt ${freq7} ] ; then
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load ] ; then
   count_num
   chwrite $hispeed_load /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu1/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu2/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu3/cpufreq/$GOV/go_hispeed_load
   if [ $hispeed_freq != "null" ] ; then
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu0/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu1/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu2/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu3/cpufreq/$GOV/hispeed_freq
   fi
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu4/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu5/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu6/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu7/cpufreq/$GOV/go_hispeed_load
   fi
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay ] ; then
   count_num
   chwrite $high_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu4/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu5/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu6/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu7/cpufreq/$GOV/above_hispeed_delay
   fi
  else
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load ] ; then
   count_num
   chwrite $hispeed_load /sys/devices/system/cpu/cpu4/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu5/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu6/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu7/cpufreq/$GOV/go_hispeed_load
   if [ $hispeed_freq != "null" ] ; then
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu4/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu5/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu6/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu7/cpufreq/$GOV/hispeed_freq
   fi
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu1/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu2/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu3/cpufreq/$GOV/go_hispeed_load
   fi
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay ] ; then
   count_num
   chwrite $high_delay_time /sys/devices/system/cpu/cpu7/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu6/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu5/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu4/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay
   fi
  fi
  elif [ $soc_special = "5" ] ; then
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load ] ; then
   count_num
   chwrite $hispeed_load /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu1/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu2/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu3/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu4/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu5/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu6/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu7/cpufreq/$GOV/go_hispeed_load
   fi
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/hispeed_freq ] ; then
   count_num
   if [ $hispeed_freq != "null" ] ; then
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu0/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu1/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu2/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu3/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu4/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu5/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu6/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu7/cpufreq/$GOV/hispeed_freq
   fi
   fi
   if [ -e /sys/devices/system/cpu/cpu7/cpufreq/$GOV/above_hispeed_delay ] ; then
   chwrite $high_delay_time /sys/devices/system/cpu/cpu7/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu6/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu5/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu4/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay
   fi
  fi
 elif [ $core_num = "5" ] ; then
  if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/timer_rate ] ; then
  count_num
  chwrite $min_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/timer_rate  
  chwrite $min_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu4/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu5/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu7/cpufreq/$GOV/timer_rate
  fi
  if [ ${freq0} -gt ${freq5} ] ; then
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load ] ; then
   count_num
   chwrite $hispeed_load /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu1/cpufreq/$GOV/go_hispeed_load
   if [ $hispeed_freq != "null" ] ; then
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu0/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu1/cpufreq/$GOV/hispeed_freq
   fi
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu2/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu3/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu4/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu5/cpufreq/$GOV/go_hispeed_load
   fi
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay ] ; then
   count_num
   chwrite $high_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu4/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu5/cpufreq/$GOV/above_hispeed_delay
   fi
  else
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load ] ; then
   count_num
   chwrite $hispeed_load /sys/devices/system/cpu/cpu4/cpufreq/$GOV/go_hispeed_load 
   chwrite $hispeed_load /sys/devices/system/cpu/cpu5/cpufreq/$GOV/go_hispeed_load
   if [ $hispeed_freq != "null" ] ; then
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu4/cpufreq/$GOV/hispeed_freq 
   chwrite $hispeed_freq /sys/devices/system/cpu/cpu5/cpufreq/$GOV/hispeed_freq
   fi
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu1/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu2/cpufreq/$GOV/go_hispeed_load 
   chwrite $s_hispeed_load /sys/devices/system/cpu/cpu3/cpufreq/$GOV/go_hispeed_load
   fi
   if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay ] ; then
   count_num
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/above_hispeed_delay 
   chwrite $s_high_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu4/cpufreq/$GOV/above_hispeed_delay 
   chwrite $high_delay_time /sys/devices/system/cpu/cpu5/cpufreq/$GOV/above_hispeed_delay
   fi
  fi
 elif [ $core_num = "3" ] ; then
  if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/timer_rate ] ; then
  count_num
  chwrite $min_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/timer_rate 
  chwrite $min_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/timer_rate
  fi
   if [ $soc_special = "0" ] ; then
    if [ $SOC = "msm8996" ] ; then
	if [ ${freq0} -gt ${freq3} ] ; then
	if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load ] ; then
    count_num
	chwrite $hispeed_load /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load 
    chwrite $hispeed_load /sys/devices/system/cpu/cpu1/cpufreq/$GOV/go_hispeed_load
	if [ $hispeed_freq != "null" ] ; then
    chwrite $hispeed_freq /sys/devices/system/cpu/cpu0/cpufreq/$GOV/hispeed_freq 
    chwrite $hispeed_freq /sys/devices/system/cpu/cpu1/cpufreq/$GOV/hispeed_freq
	fi
	chwrite $s_hispeed_load /sys/devices/system/cpu/cpu2/cpufreq/$GOV/go_hispeed_load 
    chwrite $s_hispeed_load /sys/devices/system/cpu/cpu3/cpufreq/$GOV/go_hispeed_load
	fi
	if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay ] ; then
    count_num
    chwrite $high_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay 
    chwrite $high_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/above_hispeed_delay 
    chwrite $s_high_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/above_hispeed_delay 
    chwrite $s_high_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/above_hispeed_delay
    fi
	else
	if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load ] ; then
    count_num
	chwrite $hispeed_load /sys/devices/system/cpu/cpu3/cpufreq/$GOV/go_hispeed_load 
    chwrite $hispeed_load /sys/devices/system/cpu/cpu2/cpufreq/$GOV/go_hispeed_load
	if [ $hispeed_freq != "null" ] ; then
    chwrite $hispeed_freq /sys/devices/system/cpu/cpu2/cpufreq/$GOV/hispeed_freq 
    chwrite $hispeed_freq /sys/devices/system/cpu/cpu3/cpufreq/$GOV/hispeed_freq
	fi
	chwrite $s_hispeed_load /sys/devices/system/cpu/cpu1/cpufreq/$GOV/go_hispeed_load 
    chwrite $s_hispeed_load /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load
	fi
	if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay ] ; then
    count_num
    chwrite $s_high_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay 
    chwrite $s_high_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/above_hispeed_delay 
    chwrite $high_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/above_hispeed_delay 
    chwrite $high_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/above_hispeed_delay
    fi
	fi
	else
    if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load ] ; then
    count_num
    chwrite $hispeed_load /sys/devices/system/cpu/cpu0/cpufreq/$GOV/go_hispeed_load 
    chwrite $hispeed_load /sys/devices/system/cpu/cpu1/cpufreq/$GOV/go_hispeed_load 
    chwrite $hispeed_load /sys/devices/system/cpu/cpu2/cpufreq/$GOV/go_hispeed_load 
    chwrite $hispeed_load /sys/devices/system/cpu/cpu3/cpufreq/$GOV/go_hispeed_load
	if [ $hispeed_freq != "null" ] ; then
    chwrite $hispeed_freq /sys/devices/system/cpu/cpu0/cpufreq/$GOV/hispeed_freq 
    chwrite $hispeed_freq /sys/devices/system/cpu/cpu1/cpufreq/$GOV/hispeed_freq 
    chwrite $hispeed_freq /sys/devices/system/cpu/cpu2/cpufreq/$GOV/hispeed_freq 
    chwrite $hispeed_freq /sys/devices/system/cpu/cpu3/cpufreq/$GOV/hispeed_freq
	fi
    fi
	if [ -e /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay ] ; then
    count_num
    chwrite $high_delay_time /sys/devices/system/cpu/cpu0/cpufreq/$GOV/above_hispeed_delay 
    chwrite $high_delay_time /sys/devices/system/cpu/cpu1/cpufreq/$GOV/above_hispeed_delay 
    chwrite $high_delay_time /sys/devices/system/cpu/cpu2/cpufreq/$GOV/above_hispeed_delay 
    chwrite $high_delay_time /sys/devices/system/cpu/cpu3/cpufreq/$GOV/above_hispeed_delay
    fi
	fi
   fi
 fi
 #适配骁龙200/400/600/80x等原始四核处理器
 if [ -d /sys/devices/system/cpu/cpufreq/interactive/ ] ; then
  count_num
  chwrite $hispeed_load /sys/devices/system/cpu/cpufreq/interactive/go_hispeed_load
  chwrite $hispeed_freq /sys/devices/system/cpu/cpufreq/interactive/hispeed_freq
  chwrite $high_delay_time /sys/devices/system/cpu/cpufreq/interactive/above_hispeed_delay
  chwrite $min_delay_time /sys/devices/system/cpu/cpufreq/interactive/timer_rate
 fi
 echo "[LOG] HMP调度 $mode 模式 Interactive 调频器优化完毕." |  tee -a $LOG;
fi
#-----------------------------------------------------------
if [ $ram_fix = "true" ] ; then
chmod 7777 /system/etc/init.ft.ram.sh
su -c /system/etc/init.ft.ram.sh &
echo "[LOG] RAM 优化已开启." |  tee -a $LOG;
else
echo "RAM优化已禁用." > /data/FastTurbo/ram_fix.log
echo "[LOG] RAM 优化已禁用." |  tee -a $LOG;
fi
#禁用uKSM---------------------------------------------------
if [ $uksm_fix = "true" ] ;then
#disable uKSM
if [ -e /sys/kernel/mm/uksm/run ] ; then
count_num
chwrite "0" "/sys/kernel/mm/uksm/run"
fi
setprop ro.config.uksm.support false
echo "[LOG] uKSM已禁用." |  tee -a $LOG;
fi
#-----------------------------------------------------------
#深度睡眠优化-----------------------------------------------
if [ $deepsleep_fix = "true" ] ; then
count_num
setprop ro.qualcomm.perf.cores_online 1
echo "[LOG] 高通深度睡眠优化完毕." |  tee -a $LOG;
fi
#-----------------------------------------------------------
#多任务优化-------------------------------------------------
if [ $drw_fix = "true" ] ; then
count_num
d_core=`echo $(($core_num + 1))`
setprop dalvik.vm.dex2oat-threads $d_core
setprop dalvik.vm.boot-dex2oat-threads $d_core
setprop persist.dalvik.vm.dex2oat-threads $d_core
setprop dalvik.vm.image-dex2oat-threads $d_core
setprop ro.sys.fw.dex2oat_thread_count $d_core
echo "[LOG] 虚拟机 $d_core 线程优化已开启." |  tee -a $LOG;
fi
#-----------------------------------------------------------
#调整电源策略及GPU加速策略----------------------------------
if [ $mode = "gamexe" ] ; then
if [ -e /sys/module/workqueue/parameters/power_efficient ]; then
count_num
chwrite "N" /sys/module/workqueue/parameters/power_efficient
echo "[LOG] 内核 PowerSave 已关闭." |  tee -a $LOG;
fi;
if [ -e /sys/kernel/sched/arch_power ]; then
count_num
chwrite "0" /sys/kernel/sched/arch_power
echo "[LOG] Arch Power 已关闭." |  tee -a $LOG;
fi;
elif [ $mode = "turbo" ] ; then
if [ -e /sys/module/workqueue/parameters/power_efficient ]; then
count_num
chwrite "N" /sys/module/workqueue/parameters/power_efficient
echo "[LOG] 内核 PowerSave 已关闭." |  tee -a $LOG;
fi;
if [ -e /sys/kernel/sched/arch_power ]; then
count_num
chwrite "0" /sys/kernel/sched/arch_power
echo "[LOG] Arch Power 已关闭." |  tee -a $LOG;
fi;
elif [ $mode = "balance" ] ; then
if [ -e /sys/module/workqueue/parameters/power_efficient ]; then
count_num
chwrite "Y" /sys/module/workqueue/parameters/power_efficient
echo "[LOG] 内核 PowerSave 已开启." |  tee -a $LOG;
fi;
if [ -e /sys/kernel/sched/arch_power ]; then
count_num
chwrite "1" /sys/kernel/sched/arch_power
echo "[LOG] Arch Power 已开启." |  tee -a $LOG;
fi;
else
if [ -e /sys/module/workqueue/parameters/power_efficient ]; then
count_num
chwrite "Y" /sys/module/workqueue/parameters/power_efficient
echo "[LOG] 内核 PowerSave 已开启." |  tee -a $LOG;
fi;
if [ -e /sys/kernel/sched/arch_power ]; then
count_num
chwrite "1" /sys/kernel/sched/arch_power
echo "[LOG] Arch Power 已开启." |  tee -a $LOG;
fi;
fi
if [ -e /sys/class/lcd/panel/power_reduce ] ; then
count_num
chwrite "1" /sys/class/lcd/panel/power_reduce
echo "[LOG] LCD 优化已开启." |  tee -a $LOG;
fi
#--------------------------------------------------------------
#执行fstrim----------------------------------------------------
if [ -e /system/bin/busybox ] ; then
su -c busybox fstrim -v /cache 
su -c busybox fstrim -v /data 
su -c busybox fstrim -v /system
echo "[LOG] Linux Fstrim 执行完毕." |  tee -a $LOG;
fi
#--------------------------------------------------------------
#计算优化项目--------------------------------------------------
echo "* 共 $FT_PASS 项优化执行完毕." |  tee -a $LOG;
echo "* 全部项目执行完毕,结束时间:$(date)" |  tee -a $LOG;
#--------------------------------------------------------------
#结束程序
chmod -R 7777 /data/FastTurbo/ 
echo "1" > /data/FastTurbo/done
echo " " |  tee -a $LOG;
if [ $smai_mode = "full" ] ; then
echo "* FastTurbo Smart Ability 效率模式已启动." |  tee -a $LOG;
chmod 7777 /system/etc/init.ft.smart.sh
su -c sh /system/etc/init.ft.smart.sh
elif [ $smai_mode = "stop" ] ; then
echo "* FastTurbo Smart Ability 已停用." |  tee -a $LOG;
echo "[FastTurbo Smart Ability] 已停用." > /data/FastTurbo/SmartAI/core_info.log
chmod 7777 /system/etc/init.ft.mode.sh
su -c sh /system/etc/init.ft.mode.sh
elif [ $smai_mode = "part" ] ; then
echo "* FastTurbo Smart Ability 兼容模式已启动." |  tee -a $LOG;
chmod 7777 /system/etc/init.sa.simplesa.sh
su -c sh /system/etc/init.sa.simplesa.sh
fi
exit 0

