#!/system/bin/sh
#ZRAM调整------------------------------------------------
chmod 7777 /system/bin/chwrite
LOG="/data/FastTurbo/ram_fix.log"
echo "* 初始化内存优化..." > $LOG
if [ -e /data/FastTurbo/zmode ] ; then
ZR=$(cat /data/FastTurbo/zmode)
else
ZR="512"
echo "512" > /data/FastTurbo/zmode
fi
if [ -e /data/FastTurbo/kmode ] ; then
k_mode=$(cat /data/FastTurbo/kmode)
else
k_mode="little"
echo "little" > /data/FastTurbo/kmode
fi
function setpropex() {
 MODDIR=$(cat /data/FastTurbo/moddir)
 SYSTEMPROP_FILE="$MODDIR/system.prop"
 if [ ! -e $SYSTEMPROP_FILE ] ; then
 touch $SYSTEMPROP_FILE
 else
 chmod 0666 $SYSTEMPROP_FILE
 echo "$1" |  tee -a $SYSTEMPROP_FILE;
 fi
}
function clearprop() {
 MODDIR=$(cat /data/FastTurbo/moddir)
 SYSTEMPROP_FILE="$MODDIR/system.prop"
 if [ ! -e $SYSTEMPROP_FILE ] ; then
 touch $SYSTEMPROP_FILE
 else
 chmod 0666 $SYSTEMPROP_FILE
 echo " " > $SYSTEMPROP_FILE
 fi
}
#Get ZRAM SIZE NOW
if [ -e /sys/block/zram0/disksize ] ; then
 ZRAM_NOW=$(cat /sys/block/zram0/disksize)
elif [ -e /sys/block/zram1/disksize ] ; then
 ZRAM_NOW=$(cat /sys/block/zram1/disksize)
elif [ -e /sys/block/zram2/disksize ] ; then
 ZRAM_NOW=$(cat /sys/block/zram2/disksize)
else
 ZRAM_NOW="0"
fi
ZR_CHECK=`echo $(($ZR*1024*1024))`
if [ ${ZR_CHECK} -ne ${ZRAM_NOW} ] ; then
if [ ${ZR} -gt 0 ] ; then
zram_streams=`echo $(($core_num + 1))`
ZRAM_ENABLED="false"
if [ -e /dev/block/zram0 ]; then
 ZRAM_ENABLED="true"
 swapoff /dev/block/zram0
 chwrite "1" /sys/block/zram0/reset
 chwrite "$((ZR*1024*1024))" /sys/block/zram0/disksize 
 if [ $mode = "powersave" ] ; then
 chwrite "lz0" /sys/block/zram0/comp_algorithm
 else
 chwrite "lz4" /sys/block/zram0/comp_algorithm
 fi
 chwrite $zram_streams /sys/block/zram0/max_comp_streams
 mkswap /dev/block/zram0
 swapon /dev/block/zram0
 setprop vnswap.enabled true
 setprop ro.config.zram true
 setprop ro.config.zram.support true
 setprop zram.disksize $ZR
fi
if [ -e /dev/block/zram1 ]; then
 ZRAM_ENABLED="true"
 swapoff /dev/block/zram1
 chwrite "1" /sys/block/zram1/reset
 chwrite "$((ZR*1024*1024))" /sys/block/zram1/disksize 
 if [ $mode = "powersave" ] ; then
 chwrite "lz0" /sys/block/zram1/comp_algorithm
 else
 chwrite "lz4" /sys/block/zram1/comp_algorithm
 fi
 chwrite $zram_streams /sys/block/zram1/max_comp_streams
 mkswap /dev/block/zram1
 swapon /dev/block/zram1
 setprop vnswap.enabled true
 setprop ro.config.zram true
 setprop ro.config.zram.support true
 setprop zram.disksize $ZR
fi
if [ -e /dev/block/zram2 ]; then
 ZRAM_ENABLED="true"
 swapoff /dev/block/zram2
 chwrite "1" /sys/block/zram2/reset
 chwrite "$((ZR*1024*1024))" /sys/block/zram2/disksize
 if [ $mode = "powersave" ] ; then
 chwrite "lz0" /sys/block/zram2/comp_algorithm
 else
 chwrite "lz4" /sys/block/zram2/comp_algorithm
 fi
 chwrite $zram_streams /sys/block/zram2/max_comp_streams
 mkswap /dev/block/zram2
 swapon /dev/block/zram2
 setprop vnswap.enabled true
 setprop ro.config.zram true
 setprop ro.config.zram.support true
 setprop zram.disksize $ZR
fi
if [ $ZRAM_ENABLED = "true" ] ; then
echo "* $ZR mb ZRAM 已开启" |  tee -a $LOG;
else
echo "* 内核不支持调整ZRAM大小." |  tee -a $LOG;
fi
if [ -e /sys/module/zswap/parameters/enabled ]; then
 if [ -e /sys/module/zswap/parameters/enabled ]; then
  chwrite "Y" /sys/module/zswap/parameters/enabled
 fi
 if [ -e /sys/module/zswap/parameters/max_pool_percent ]; then
  chwrite "100" /sys/module/zswap/parameters/max_pool_percent
 fi
fi
else
if [ -e /dev/block/zram0 ]; then
 swapoff /dev/block/zram0
 setprop vnswap.enabled false
 setprop ro.config.zram false
 setprop ro.config.zram.support false
 setprop zram.disksize 0
fi
if [ -e /dev/block/zram1 ]; then
 swapoff /dev/block/zram1
 setprop vnswap.enabled false
 setprop ro.config.zram false
 setprop ro.config.zram.support false
 setprop zram.disksize 0
fi
if [ -e /dev/block/zram2 ]; then
 swapoff /dev/block/zram2
 setprop vnswap.enabled false
 setprop ro.config.zram false
 setprop ro.config.zram.support false
 setprop zram.disksize 0
fi
echo "* ZRAM 已关闭." |  tee -a $LOG;
fi
fi
#---------------------------------------------------------------
#Low Memory Killer 优化-------------------------------------
if [ -d /sys/module/lowmemorykiller/parameters/ ] ; then
if [ -e /sys/module/lowmemorykiller/parameters/debug_level ] ; then
chwrite 0 /sys/module/lowmemorykiller/parameters/debug_level
fi
if [ -e "/sys/module/lowmemorykiller/parameters/enable_adaptive_lmk" ]; then
chwrite 0 /sys/module/lowmemorykiller/parameters/enable_adaptive_lmk
fi
if [ -e "/sys/module/lowmemorykiller/parameters/oom_reaper" ]; then
chwrite 1 /sys/module/lowmemorykiller/parameters/oom_reaper
fi
RAM_SIZE=0
if [ -e /proc/meminfo ] ; then
 MEM_INFO=$(cat /proc/meminfo | grep MemTotal)
 ram_value_right=`echo ${MEM_INFO#*:}`
 RAM_SIZE=`echo ${ram_value_right%kB*}`
elif [ -e /system/bin/free ] ; then
 RAM_SIZE=$(free | grep Mem | awk '{print $2}')
 if [ ${RAM_SIZE} -gt 1638400 ] ; then
  RAM_SIZE=$(($RAM_SIZE/1024))
 fi
fi
if [ ${RAM_SIZE} -lt 0 ] ; then
 echo "* RAM大小获取失败,RAM优化自动中止. " |  tee -a $LOG;
 exit 0
fi
#Base on 1024mb RAM_SIZE Value
b_LMK1=8192 #32mb FOREGROUND_APP
b_LMK2=12288 #48mb VISIBLE_APP
b_LMK3=16384 #64mb SECONDARY_SERVER
b_LMK4=20480 #80mb HIDDEN_APP
b_LMK5=32768 #128mb CONTENT_PROVIDER
b_LMK6=49152 #192mb EMPTY_APP
if [ $k_mode = "light" ] ; then
killer_level=14
elif [ $k_mode = "balanced" ] ; then
killer_level=12
elif [ $k_mode = "little" ] ; then
killer_level=10
elif [ $k_mode = "sleep" ] ; then
killer_level=8
else
killer_level=10
echo "balanced" > /data/FastTurbo/kmode
fi
RAM_LEVEL=$(($RAM_SIZE/900000))
LMK1=$(($b_LMK1 * $RAM_LEVEL * $killer_level / 10 ))
LMK2=$(($b_LMK2 * $RAM_LEVEL * $killer_level / 10 ))
LMK3=$(($b_LMK3 * $RAM_LEVEL * $killer_level / 10 ))
LMK4=$(($b_LMK4 * $RAM_LEVEL * $killer_level / 10 ))
LMK5=$(($b_LMK5 * $RAM_LEVEL * $killer_level / 10 ))
LMK6=$(($b_LMK6 * $RAM_LEVEL * $killer_level / 10 ))
if [ -e "/sys/module/lowmemorykiller/parameters/minfree" ]; then
chwrite "$LMK1,$LMK2,$LMK3,$LMK4,$LMK5,$LMK6" /sys/module/lowmemorykiller/parameters/minfree
fi
setprop lmk.autocalc false
setprop ro.sys.fw.bg_apps_limit 50
setprop ro.vendor.qti.sys.fw.bg_apps_limit 50
setprop ro.FOREGROUND_APP_MEM $LMK1
setprop ro.VISIBLE_APP_MEM $LMK2
setprop ro.SECONDARY_SERVER_MEM $LMK3
setprop ro.HIDDEN_APP_MEM $LMK4
setprop ro.CONTENT_PROVIDER_MEM $LMK5
setprop ro.EMPTY_APP_MEM $LMK6
if [ -e /sys/module/lowmemorykiller/parameters/adj ] ; then
chwrite "1,100,200,300,800,950" /sys/module/lowmemorykiller/parameters/adj
fi
if [ -e /sys/module/lowmemorykiller/parameters/vmpressure_file_min ] ; then
chwrite "$((65536*$RAM_LEVEL))" /sys/module/lowmemorykiller/parameters/vmpressure_file_min 
fi
echo "* LMK Minfree 数据: " |  tee -a $LOG
echo "* $LMK1,$LMK2,$LMK3,$LMK4,$LMK5,$LMK6" |  tee -a $LOG
echo "* $k_mode 模式 Low Memory Killer 工作中." |  tee -a $LOG
else
if [ $k_mode = "light" ] ; then
count_value="10"
up_press="70"
down_press="50"
elif [ $k_mode = "balanced" ] ; then
count_value="12"
up_press="80"
down_press="60"
elif [ $k_mode = "little" ] ; then
count_value="14"
up_press="90"
down_press="70"
else
count_value="15"
up_press="95"
down_press="75"
fi
lmk_low_info="80"
lmk_mid_info="70"
LMK_LOW=`echo $(($lmk_low_info*$count_value))`
LMK_MID=`echo $(($lmk_mid_info*$count_value))`
if [ ${LMK_LOW} -gt 1000 ] ; then
LMK_LOW="1000"
fi
if [ ${LMK_MID} -gt 1000 ] ; then
LMK_MID="1000"
fi
setprop ro.lmk.use_minfree_levels true
setprop ro.lmk.low $LMK_LOW
setprop ro.lmk.medium $LMK_MID
setprop ro.lmk.upgrade_pressure $up_press
setprop ro.lmk.downgrade_pressure $down_press
setprop ro.lmk.extra_medium 400
setprop ro.lmk.extra_critical 400
setprop ro.lmk.critical 0
setprop ro.lmk.critical_upgrade true
setprop ro.lmk.kill_timeout_ms 100
setprop ro.lmk.kill_heaviest_task true
setprop ro.lmk.debug false
setprop lmk.autocalc false
setprop ro.sys.fw.bg_apps_limit 50
setprop ro.vendor.qti.sys.fw.bg_apps_limit 50
setprop ro.FOREGROUND_APP_MEM 0
setprop ro.VISIBLE_APP_MEM 117
setprop ro.SECONDARY_SERVER_MEM 235
setprop ro.HIDDEN_APP_MEM 411
setprop ro.CONTENT_PROVIDER_MEM 823
setprop ro.EMPTY_APP_MEM 1000
echo "* $k_mode 模式 Low Memory Killer Daemon 工作中." |  tee -a $LOG
#check if lmkd is changed
LMKD_CHECK_VALUE=""
LMKD_CHECK_VALUE=$(getprop ro.lmk.low)
if [ "$LMKD_CHECK_VALUE" != "$LMK_LOW" ] ; then
echo "* 你的系统不支持 setprop方式 修改." |  tee -a $LOG
clearprop
setpropex "ro.lmk.use_minfree_levels=true"
setpropex "ro.lmk.low=$LMK_LOW"
setpropex "ro.lmk.medium=$LMK_MID"
setpropex "ro.lmk.upgrade_pressure=$up_press"
setpropex "ro.lmk.downgrade_pressure=$down_press"
setpropex "ro.lmk.extra_medium=400"
setpropex "ro.lmk.extra_critical=400"
setpropex "ro.lmk.critical=0"
setpropex "ro.lmk.critical_upgrade=true"
setpropex "ro.lmk.kill_timeout_ms=80"
setpropex "ro.lmk.kill_heaviest_task=true"
setpropex "ro.lmk.debug=false"
echo "* 已改变LMKD调整策略,请手动重启以生效." |  tee -a $LOG
fi
fi
echo "* 内存优化完成,结束时间:$(date)" |  tee -a $LOG
exit 0
