#!/system/bin/sh
#--------------------------------------------------------------------------------
#FastTurbo SmartAbility V7.x                                                           
#Author:@Chenzyadb (xda,coolapk,bilibili,github,gitee)       
#E-Mail:chenzyadb@qq.com 
#Test:@Chinatsu Moss & @Amakuni Moss 
#Copyright © Chenzyadb 2020 All Rights Reserved.
#--------------------------------------------------------------------------------
SMART_PID=$$
echo "$SMART_PID" > /data/FastTurbo/SmartAI/smart_pid
chmod 7777 /system/bin/chwrite
echo "[FastTurbo Smart Ability] V7.0 STABLE " > /data/FastTurbo/SmartAI/core_info.log
LOG="/data/FastTurbo/SmartAI/core_info.log"
echo "* time : $(date) 初始化 SmartAbility ... " |  tee -a $LOG;
#Get Info------------------------------------------------------
SOC="null"
SOC=$(getprop ro.board.platform)
if [ $SOC = "null" ] ; then
SOC=$(getprop ro.chipname)
fi
case $SOC in mt*)
MTK="true"
esac
JP_FUNCTION=$(cat /data/FastTurbo/jp_function)
if [ -e /sys/devices/system/cpu/kernel_max ] ; then
core_num=$(cat /sys/devices/system/cpu/kernel_max)
elif [ -d /sys/devices/system/cpu/cpu9/ ] ; then
core_num="9"
elif [ -d /sys/devices/system/cpu/cpu7/ ] ; then
core_num="7"
elif [ -d /sys/devices/system/cpu/cpu5/ ] ; then
core_num="5"
elif [ -d /sys/devices/system/cpu/cpu3/ ] ; then
core_num="3"
fi
soc_special=$(cat /data/FastTurbo/SmartAI/soc_special)
mode=$(cat /data/FastTurbo/mode)
if [ $core_num = "9" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
freq6=$(cat /data/FastTurbo/SmartAI/cpu_freq6)
freq7=$(cat /data/FastTurbo/SmartAI/cpu_freq7)
freq8=$(cat /data/FastTurbo/SmartAI/cpu_freq8)
freq9=$(cat /data/FastTurbo/SmartAI/cpu_freq9)
elif [ $core_num = "7" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
freq6=$(cat /data/FastTurbo/SmartAI/cpu_freq6)
freq7=$(cat /data/FastTurbo/SmartAI/cpu_freq7)
elif [ $core_num = "5" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
elif [ $core_num = "3" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
fi
if [ -e /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies ] ; then
available_freq_1=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu4/cpufreq/scaling_available_frequencies ] ; then
available_freq_2=$(cat /sys/devices/system/cpu/cpu4/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu8/cpufreq/scaling_available_frequencies ] ; then
available_freq_3=$(cat /sys/devices/system/cpu/cpu8/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu6/cpufreq/scaling_available_frequencies ] ; then
available_freq_4=$(cat /sys/devices/system/cpu/cpu6/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu3/cpufreq/scaling_available_frequencies ] ; then
available_freq_5=$(cat /sys/devices/system/cpu/cpu3/cpufreq/scaling_available_frequencies)
fi
if [ -e /sys/devices/system/cpu/cpu2/cpufreq/scaling_available_frequencies ] ; then
available_freq_a=$(cat /sys/devices/system/cpu/cpu2/cpufreq/scaling_available_frequencies)
fi
#---------------------------------------------------------------
if [ $mode = "turbo" ] ; then 
echo "* Turbo模式温度监控已启动." |  tee -a $LOG;
echo "* Turbo模式GAME BOOST监测已启动." |  tee -a $LOG;
echo "* Turbo模式核心负载监测已启动." |  tee -a $LOG;
echo "* Turbo模式温控 SOC:60°C/70°C , 电池:50°C." |  tee -a $LOG;
elif [ $mode = "balance" ] ; then
echo "* Balance模式温度监控已启动." |  tee -a $LOG;
echo "* Balance模式异常耗电监控已启动." |  tee -a $LOG;
echo "* Balance模式核心负载监测已启动." |  tee -a $LOG;
echo "* Balance模式APP BOOST监测已启动." |  tee -a $LOG;
echo "* Balance模式温控 SOC:50°C/60°C , 电池:45°C." |  tee -a $LOG;
elif [ $mode = "powersave" ] ; then
echo "* PowerSave模式温度监控已启动." |  tee -a $LOG;
echo "* PowerSave模式异常耗电监控已启动." |  tee -a $LOG;
echo "* PowerSave模式APP BOOST监测已启动." |  tee -a $LOG;
echo "* PowerSave模式温控 SOC:45°C/55°C , 电池:40°C." |  tee -a $LOG;
elif [ $mode = "gamexe" ] ; then
echo "[ Game X Extreme 电竞模式已开启 ]" |  tee -a $LOG;
echo "* GameXE模式GAME BOOST监测已启动." |  tee -a $LOG;
fi
echo " " |  tee -a $LOG;
CHANGED_COUNT="0"
STOP_SA_DAEMON="false"
#Start Daemons
chmod 7777 /system/etc/init.sa.game.sh
su -c sh /system/etc/init.sa.game.sh &
chmod 7777 /system/etc/init.sa.mode.sh
su -c sh /system/etc/init.sa.mode.sh &
chmod 7777 /system/etc/init.sa.thermal.sh
su -c sh /system/etc/init.sa.thermal.sh &
chmod 7777 /system/etc/init.sa.smartmind.sh
su -c sh /system/etc/init.sa.smartmind.sh &
#Check Function-------------------------------------------------
while true ; do
OVERTEMP_LEVEL=$(cat /data/FastTurbo/SmartAI/overtemp_level)
GAME_BOOST=$(cat /data/FastTurbo/SmartAI/game_boost)
APP_BOOST=$(cat /data/FastTurbo/SmartAI/app_boost)
#Get Screen State
SCREEN_STATE=$(su -c dumpsys window policy | grep screenState )
SCREEN_OFF="false"
case $SCREEN_STATE in *"SCREEN_STATE_OFF"*)
SCREEN_OFF="true"
esac
case $SCREEN_STATE in *"1"*)
SCREEN_OFF="true"
esac
if [ $SCREEN_OFF = "true" ] ; then 
if [ $STOP_SA_DAEMON = "false" ] ; then
echo "[LOG][$(date +%T)] 监测到系统进入熄屏状态,已暂停SmartAbility." |  tee -a $LOG;
fi
STOP_SA_DAEMON="true"
MODE_PID=$(cat /data/FastTurbo/SmartAI/mode_pid)
THERMAL_PID=$(cat /data/FastTurbo/SmartAI/thermal_pid)
MIND_PID=$(cat /data/FastTurbo/SmartAI/mind_pid)
GAME_PID=$(cat /data/FastTurbo/SmartAI/game_pid)
su -c kill $GAME_PID 2>/dev/null
su -c kill $MODE_PID 2>/dev/null
su -c kill $THERMAL_PID 2>/dev/null
su -c kill $MIND_PID 2>/dev/null
if [ $MTK = "true" ] ; then
 if [ -e /proc/hps/enabled ] ; then
  HPS_STATE=$(cat /proc/hps/enabled)
  if [ $HPS_STATE = "0" ] ; then
   chwrite "1" "/proc/hps/enabled"
  fi
 fi
fi
else
if [ $STOP_SA_DAEMON = "true" ] ; then
STOP_SA_DAEMON="false"
#Start Daemons
chmod 7777 /system/etc/init.sa.game.sh
su -c sh /system/etc/init.sa.game.sh &
chmod 7777 /system/etc/init.sa.mode.sh
su -c sh /system/etc/init.sa.mode.sh &
chmod 7777 /system/etc/init.sa.thermal.sh
su -c sh /system/etc/init.sa.thermal.sh &
chmod 7777 /system/etc/init.sa.smartmind.sh
su -c sh /system/etc/init.sa.smartmind.sh &
echo "[LOG][$(date +%T)] 监测到系统退出熄屏状态,已重启SmartAbility." |  tee -a $LOG;
fi
if [ $MTK = "true" ] ; then
 if [ -e /proc/hps/enabled ] ; then
  HPS_STATE=$(cat /proc/hps/enabled)
  if [ $HPS_STATE = "1" ] ; then
   chwrite "0" "/proc/hps/enabled"
  fi
 fi
fi
NOW_JP=$(cat /data/FastTurbo/now_jp)
if [ $core_num = "9" ] ; then
CPU0_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu0_online)
CPU1_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu1_online)
CPU2_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu2_online)
CPU3_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu3_online)
CPU4_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu4_online)
CPU5_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu5_online)
CPU6_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu6_online)
CPU7_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu7_online)
CPU8_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu8_online)
CPU9_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu9_online)
CPU0_ONLINE=$(cat /sys/devices/system/cpu/cpu0/online)
CPU1_ONLINE=$(cat /sys/devices/system/cpu/cpu1/online)
CPU2_ONLINE=$(cat /sys/devices/system/cpu/cpu2/online)
CPU3_ONLINE=$(cat /sys/devices/system/cpu/cpu3/online)
CPU4_ONLINE=$(cat /sys/devices/system/cpu/cpu4/online)
CPU5_ONLINE=$(cat /sys/devices/system/cpu/cpu5/online)
CPU6_ONLINE=$(cat /sys/devices/system/cpu/cpu6/online)
CPU7_ONLINE=$(cat /sys/devices/system/cpu/cpu7/online)
CPU8_ONLINE=$(cat /sys/devices/system/cpu/cpu8/online)
CPU9_ONLINE=$(cat /sys/devices/system/cpu/cpu9/online)
if [ ${CPU0_ONLINE} != ${CPU0_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU0_ONLINE_INFO" "/sys/devices/system/cpu/cpu0/online"
fi
if [ ${CPU1_ONLINE} != ${CPU1_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU1_ONLINE_INFO" "/sys/devices/system/cpu/cpu1/online"
fi
if [ ${CPU2_ONLINE} != ${CPU2_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU2_ONLINE_INFO" "/sys/devices/system/cpu/cpu2/online"
fi
if [ ${CPU3_ONLINE} != ${CPU3_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU3_ONLINE_INFO" "/sys/devices/system/cpu/cpu3/online"
fi
if [ ${CPU4_ONLINE} != ${CPU4_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU4_ONLINE_INFO" "/sys/devices/system/cpu/cpu4/online"
fi
if [ ${CPU5_ONLINE} != ${CPU5_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU5_ONLINE_INFO" "/sys/devices/system/cpu/cpu5/online"
fi
if [ ${CPU6_ONLINE} != ${CPU6_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU6_ONLINE_INFO" "/sys/devices/system/cpu/cpu6/online"
fi
if [ ${CPU7_ONLINE} != ${CPU7_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU7_ONLINE_INFO" "/sys/devices/system/cpu/cpu7/online"
fi
if [ ${CPU8_ONLINE} != ${CPU8_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU8_ONLINE_INFO" "/sys/devices/system/cpu/cpu8/online"
fi
if [ ${CPU9_ONLINE} != ${CPU9_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU9_ONLINE_INFO" "/sys/devices/system/cpu/cpu9/online"
fi
elif [ $core_num = "7" ] ; then
CPU0_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu0_online)
CPU1_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu1_online)
CPU2_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu2_online)
CPU3_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu3_online)
CPU4_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu4_online)
CPU5_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu5_online)
CPU6_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu6_online)
CPU7_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu7_online)
CPU0_ONLINE=$(cat /sys/devices/system/cpu/cpu0/online)
CPU1_ONLINE=$(cat /sys/devices/system/cpu/cpu1/online)
CPU2_ONLINE=$(cat /sys/devices/system/cpu/cpu2/online)
CPU3_ONLINE=$(cat /sys/devices/system/cpu/cpu3/online)
CPU4_ONLINE=$(cat /sys/devices/system/cpu/cpu4/online)
CPU5_ONLINE=$(cat /sys/devices/system/cpu/cpu5/online)
CPU6_ONLINE=$(cat /sys/devices/system/cpu/cpu6/online)
CPU7_ONLINE=$(cat /sys/devices/system/cpu/cpu7/online)
if [ ${CPU0_ONLINE} != ${CPU0_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU0_ONLINE_INFO" "/sys/devices/system/cpu/cpu0/online"
fi
if [ ${CPU1_ONLINE} != ${CPU1_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU1_ONLINE_INFO" "/sys/devices/system/cpu/cpu1/online"
fi
if [ ${CPU2_ONLINE} != ${CPU2_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU2_ONLINE_INFO" "/sys/devices/system/cpu/cpu2/online"
fi
if [ ${CPU3_ONLINE} != ${CPU3_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU3_ONLINE_INFO" "/sys/devices/system/cpu/cpu3/online"
fi
if [ ${CPU4_ONLINE} != ${CPU4_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU4_ONLINE_INFO" "/sys/devices/system/cpu/cpu4/online"
fi
if [ ${CPU5_ONLINE} != ${CPU5_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU5_ONLINE_INFO" "/sys/devices/system/cpu/cpu5/online"
fi
if [ ${CPU6_ONLINE} != ${CPU6_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU6_ONLINE_INFO" "/sys/devices/system/cpu/cpu6/online"
fi
if [ ${CPU7_ONLINE} != ${CPU7_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU7_ONLINE_INFO" "/sys/devices/system/cpu/cpu7/online"
fi
elif [ $core_num = "5" ] ; then
CPU0_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu0_online)
CPU1_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu1_online)
CPU2_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu2_online)
CPU3_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu3_online)
CPU4_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu4_online)
CPU5_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu5_online)
CPU0_ONLINE=$(cat /sys/devices/system/cpu/cpu0/online)
CPU1_ONLINE=$(cat /sys/devices/system/cpu/cpu1/online)
CPU2_ONLINE=$(cat /sys/devices/system/cpu/cpu2/online)
CPU3_ONLINE=$(cat /sys/devices/system/cpu/cpu3/online)
CPU4_ONLINE=$(cat /sys/devices/system/cpu/cpu4/online)
CPU5_ONLINE=$(cat /sys/devices/system/cpu/cpu5/online)
if [ ${CPU0_ONLINE} != ${CPU0_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU0_ONLINE_INFO" "/sys/devices/system/cpu/cpu0/online"
fi
if [ ${CPU1_ONLINE} != ${CPU1_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU1_ONLINE_INFO" "/sys/devices/system/cpu/cpu1/online"
fi
if [ ${CPU2_ONLINE} != ${CPU2_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU2_ONLINE_INFO" "/sys/devices/system/cpu/cpu2/online"
fi
if [ ${CPU3_ONLINE} != ${CPU3_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU3_ONLINE_INFO" "/sys/devices/system/cpu/cpu3/online"
fi
if [ ${CPU4_ONLINE} != ${CPU4_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU4_ONLINE_INFO" "/sys/devices/system/cpu/cpu4/online"
fi
if [ ${CPU5_ONLINE} != ${CPU5_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU5_ONLINE_INFO" "/sys/devices/system/cpu/cpu5/online"
fi
elif [ $core_num = "3" ] ; then
CPU0_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu0_online)
CPU1_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu1_online)
CPU2_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu2_online)
CPU3_ONLINE_INFO=$(cat /data/FastTurbo/SmartAI/cpu3_online)
CPU0_ONLINE=$(cat /sys/devices/system/cpu/cpu0/online)
CPU1_ONLINE=$(cat /sys/devices/system/cpu/cpu1/online)
CPU2_ONLINE=$(cat /sys/devices/system/cpu/cpu2/online)
CPU3_ONLINE=$(cat /sys/devices/system/cpu/cpu3/online)
if [ ${CPU0_ONLINE} != ${CPU0_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU0_ONLINE_INFO" "/sys/devices/system/cpu/cpu0/online"
fi
if [ ${CPU1_ONLINE} != ${CPU1_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU1_ONLINE_INFO" "/sys/devices/system/cpu/cpu1/online"
fi
if [ ${CPU2_ONLINE} != ${CPU2_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU2_ONLINE_INFO" "/sys/devices/system/cpu/cpu2/online"
fi
if [ ${CPU3_ONLINE} != ${CPU3_ONLINE_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$CPU3_ONLINE_INFO" "/sys/devices/system/cpu/cpu3/online"
fi
fi
#Check GPU Governor
GPU_DIR=$(cat /data/FastTurbo/SmartAI/gpu_dir)
GPU_SUB=$(cat /data/FastTurbo/SmartAI/gpu_sub)
if [ $GPU_SUB = "mali" ] ; then
 if [ -e $GPU_DIR/devfreq/gpufreq/governor ] ; then
 GPU_GOV=$(cat $GPU_DIR/devfreq/gpufreq/governor)
 if [ $GPU_GOV != "mali_ondemand" ] ; then
  KERNEL_CHANGED="true"
  chwrite "mali_ondemand" $GPU_DIR/devfreq/gpufreq/governor
 fi
 fi
else
if [ -e $GPU_DIR/devfreq/governor ] ; then
 GPU_GOV=$(cat $GPU_DIR/devfreq/governor)
 if [ $GPU_GOV != "simple_ondemand" ] ; then
  KERNEL_CHANGED="true"
  chwrite "simple_ondemand" $GPU_DIR/devfreq/governor
 fi
 fi
fi
#Check Adreno MAX Powerlevel & AdrenoBoost 
if [ $GPU_SUB = "adreno" ] ; then
if [ -e $GPU_DIR/max_pwrlevel ] ; then
MAX_POWERLEVEL_INFO=$(cat /data/FastTurbo/SmartAI/adreno_maxpwrlevel)
MAX_POWERLEVEL=$(cat $GPU_DIR/max_pwrlevel)
ADRENOBOOST_INFO=$(cat /data/FastTurbo/SmartAI/adreno_boost)
GPU_HIGH=$(cat $GPU_DIR/num_pwrlevels)
if [ -e $GPU_DIR/devfreq/adrenoboost ] ; then
ADRENOBOOST=$(cat $GPU_DIR/devfreq/adrenoboost)
fi
if [ $OVERTEMP_LEVEL = "0" ] ; then
 if [ ${MAX_POWERLEVEL} -ne ${MAX_POWERLEVEL_INFO} ] ; then
 KERNEL_CHANGED="true"
 chwrite "$MAX_POWERLEVEL_INFO" "$GPU_DIR/max_pwrlevel"
 fi
elif [ $OVERTEMP_LEVEL = "2" ] ; then
 if [ $GAME_BOOST != "true" -a $APP_BOOST != "true" ] ; then
  if [ ${GPU_HIGH} -lt 6 ] ; then 
   chwrite "$(($MAX_POWERLEVEL_INFO + 1))" "$GPU_DIR/max_pwrlevel"
  else
   chwrite "$(($MAX_POWERLEVEL_INFO + 2))" "$GPU_DIR/max_pwrlevel"
  fi
 fi
fi
if [ $OVERTEMP_LEVEL = "0" ] ; then
 if [ -e $GPU_DIR/devfreq/adrenoboost ] ; then
  if [ ${ADRENOBOOST} -ne ${ADRENOBOOST_INFO} ] ; then
   chwrite "$ADRENOBOOST_INFO" "$GPU_DIR/devfreq/adrenoboost"
  fi
 fi
else
 if [ -e $GPU_DIR/devfreq/adrenoboost ] ; then
  chwrite "0" "$GPU_DIR/devfreq/adrenoboost"
 fi
fi
fi
fi
#Check Mali GPU 
if [ $GPU_SUB = "mali" ] ; then
if [ -e $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_upthreshold ] ; then
VSYNCUP_INFO=$(cat /data/FastTurbo/SmartAI/mali_vsync_up)
VSYNCDOWN_INFO=$(cat /data/FastTurbo/SmartAI/mali_vsync_down)
NO_VSYNCUP_INFO=$(cat /data/FastTurbo/SmartAI/mali_novsync_up)
NO_VSYNCDOWN_INFO=$(cat /data/FastTurbo/SmartAI/mali_novsync_down)
VSYNCUP=$(cat $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_upthreshold)
VSYNCDOWN=$(cat $GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_downdifferential)
NO_VSYNCUP=$(cat $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_upthreshold)
NO_VSYNCDOWN=$(cat $GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_downdifferential)
if [ ${VSYNCUP} -ne ${VSYNCUP_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$VSYNCUP_INFO" "$GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_upthreshold"
fi
if [ ${VSYNCDOWN} -ne ${VSYNCDOWN_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$VSYNCDOWN_INFO" "$GPU_DIR/devfreq/gpufreq/mali_ondemand/vsync_downdifferential"
fi
if [ ${NO_VSYNCUP} -ne ${NO_VSYNCUP_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$NO_VSYNCUP_INFO" "$GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_upthreshold"
fi
if [ ${NO_VSYNCDOWN} -ne ${NO_VSYNCDOWN_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "NO_VSYNCDOWN_INFO" "$GPU_DIR/devfreq/gpufreq/mali_ondemand/no_vsync_downdifferential"
fi
fi
fi
#Check TCP
TCP=$(cat /proc/sys/net/ipv4/tcp_congestion_control)
if [ $TCP != "cubic" ] ; then
KERNEL_CHANGED="true"
sysctl -e -w net.ipv4.tcp_congestion_control="cubic"
fi
#Check Dvfs
if [ -e /proc/mali/dvfs_enable ] ; then
DVFS_ENABLE=$(cat /proc/mali/dvfs_enable)
if [ $DVFS_ENABLE != "1" ] ; then
KERNEL_CHANGED="true"
chwrite "1" "/proc/mali/dvfs_enable"
fi
fi
#Check CPU Governor
CPU_GOV_INFO=$(cat /data/FastTurbo/SmartAI/cpu_governor)
CPU_GOV=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor)
if [ "$CPU_GOV" != "$CPU_GOV_INFO" ] ; then
KERNEL_CHANGED="true"
if [ $core_num = "9" ] ; then
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu5/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu6/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu7/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu8/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu9/cpufreq/scaling_governor
elif [ $core_num = "7" ] ; then
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu5/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu6/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu7/cpufreq/scaling_governor
elif [ $core_num = "5" ] ; then
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu5/cpufreq/scaling_governor
elif [ $core_num = "3" ] ; then
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor 
chwrite "$CPU_GOV_INFO" /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor
fi
fi
#CPUSET CHECK
if [ -e /dev/cpuset/background/cpus ] ; then
CPUSET_BACKGROUND_INFO=$(cat /data/FastTurbo/SmartAI/background_cpus)
CPUSET_SYSBACKGROUND_INFO=$(cat /data/FastTurbo/SmartAI/sys_background_cpus)
CPUSET_FOREGROUND_INFO=$(cat /data/FastTurbo/SmartAI/foreground_cpus)
CPUSET_TOPAPP_INFO=$(cat /data/FastTurbo/SmartAI/topapp_cpus)
CPUSET_GAME_INFO=$(cat /data/FastTurbo/SmartAI/game_cpus)
CPUSET_BACKGROUND=$(cat /dev/cpuset/background/cpus)
CPUSET_SYSBACKGROUND=$(cat /dev/cpuset/system-background/cpus)
CPUSET_FOREGROUND=$(cat /dev/cpuset/foreground/cpus)
CPUSET_TOPAPP=$(cat /dev/cpuset/top-app/cpus)
CPUSET_GAME=$(cat /dev/cpuset/game/cpus)
CPUSET_TOPAPP_BOOST=$(cat /dev/cpuset/top-app/boost/cpus)
CPUSET_FOREGROUND_BOOST=$(cat /dev/cpuset/foreground/boost/cpus)
if [ $OVERTEMP_LEVEL = "0" -a $GAME_BOOST = "false" ] ; then
if [ "$CPUSET_BACKGROUND" != "$CPUSET_BACKGROUND_INFO" ] ; then
KERNEL_CHANGED="true"
chwrite "$CPUSET_BACKGROUND_INFO" "/dev/cpuset/background/cpus"
fi
if [ "$CPUSET_SYSBACKGROUND" != "$CPUSET_SYSBACKGROUND_INFO" ] ; then
KERNEL_CHANGED="true"
chwrite "$CPUSET_SYSBACKGROUND_INFO" "/dev/cpuset/system-background/cpus"
fi
if [ "$CPUSET_FOREGROUND" != "$CPUSET_BACKGROUND_INFO" ] ; then
KERNEL_CHANGED="true"
chwrite "$CPUSET_FOREGROUND_INFO" "/dev/cpuset/foreground/cpus"
fi
if [ "$CPUSET_TOPAPP" != "$CPUSET_TOPAPP_INFO" ] ; then
KERNEL_CHANGED="true"
chwrite "$CPUSET_TOPAPP_INFO" "/dev/cpuset/top-app/cpus"
fi
if [ "$CPUSET_GAME" != "$CPUSET_GAME_INFO" ] ; then
chwrite "$CPUSET_GAME_INFO" "/dev/cpuset/game/cpus"
fi
   if [ $core_num = "9" ] ; then
    if [ ${freq0} -gt ${freq9} ] ; then
	 if [ "$CPUSET_FOREGROUND_BOOST" != "0-1" ] ; then
	 chwrite "0-1" /dev/cpuset/foreground/boost/cpus 
	 fi
	 if [ "$CPUSET_TOPAPP_BOOST" != "0-9" ] ; then
	 chwrite "0-9" /dev/cpuset/top-app/boost/cpus 
	 fi
	else
	 if [ "$CPUSET_FOREGROUND_BOOST" != "8-9" ] ; then
	 chwrite "8-9" /dev/cpuset/foreground/boost/cpus 
	 fi
	 if [ "$CPUSET_TOPAPP_BOOST" != "0-9" ] ; then
	 chwrite "0-9" /dev/cpuset/top-app/boost/cpus 
	 fi
	fi
   elif [ $core_num = "7" ] ; then
	if [ $soc_special = "0" ] ; then
	 if [ ${freq0} -gt ${freq7} ] ; then
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-3" ] ; then
	  chwrite "0-3" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
	  fi
	 else
	  if [ "$CPUSET_FOREGROUND_BOOST" != "4-7" ] ; then
	  chwrite "4-7" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
	  fi
	 fi
	elif [ $soc_special = "1" ] ; then
	 if [ ${freq0} -gt ${freq7} ] ; then
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-1" ] ; then
	  chwrite "0-1" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
	  fi
	 else
	  if [ "$CPUSET_FOREGROUND_BOOST" != "6-7" ] ; then
	  chwrite "6-7" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
	  fi
	 fi
	elif [ $soc_special = "5" ] ; then
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-7" ] ; then
	  chwrite "0-7" /dev/cpuset/top-app/boost/cpus 
	  fi
	fi
   elif [ $core_num = "5" ] ; then
	if [ ${freq0} -gt ${freq5} ] ; then
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-1" ] ; then
	  chwrite "0-1" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-5" ] ; then
	  chwrite "0-5" /dev/cpuset/top-app/boost/cpus 
	  fi
	else
	  if [ "$CPUSET_FOREGROUND_BOOST" != "4-5" ] ; then
	  chwrite "4-5" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-5" ] ; then
	  chwrite "0-5" /dev/cpuset/top-app/boost/cpus 
	  fi
	fi
   elif [ $core_num = "3" ] ; then
    if [ $soc_special != "0" ] ; then
	if [ ${freq0} -gt ${freq3} ] ; then
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-1" ] ; then
	  chwrite "0-1" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-3" ] ; then
	  chwrite "0-3" /dev/cpuset/top-app/boost/cpus 
	  fi
	else
	  if [ "$CPUSET_FOREGROUND_BOOST" != "2-3" ] ; then
	  chwrite "2-3" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-3" ] ; then
	  chwrite "0-5" /dev/cpuset/top-app/boost/cpus 
	  fi
	fi
	else
	  if [ "$CPUSET_FOREGROUND_BOOST" != "0-3" ] ; then
	  chwrite "0-3" /dev/cpuset/foreground/boost/cpus 
	  fi
	  if [ "$CPUSET_TOPAPP_BOOST" != "0-5" ] ; then
	  chwrite "0-5" /dev/cpuset/top-app/boost/cpus 
	  fi
	fi
   fi
fi
fi
if [ $OVERTEMP_LEVEL = "0" ] ; then
if [ -e /proc/sys/kernel/sched_downmigrate ] ; then
SCHED_UP_INFO=$(cat /data/FastTurbo/SmartAI/sched_up)
SCHED_DOWN_INFO=$(cat /data/FastTurbo/SmartAI/sched_down)
SCHED_UP=$(cat /proc/sys/kernel/sched_upmigrate)
SCHED_DOWN=$(cat /proc/sys/kernel/sched_downmigrate)
if [ ${SCHED_UP} -ne ${SCHED_UP_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$SCHED_UP_INFO" "/proc/sys/kernel/sched_upmigrate"
fi
if [ ${SCHED_DOWN} -ne ${SCHED_DOWN_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$SCHED_DOWN_INFO" "/proc/sys/kernel/sched_downmigrate"
fi
fi
if [ -e /proc/hps/up_threshold ] ; then
SCHED_UP_INFO=$(cat /data/FastTurbo/SmartAI/sched_up)
SCHED_DOWN_INFO=$(cat /data/FastTurbo/SmartAI/sched_down)
THRES_UP=$(cat /proc/hps/up_threshold)
THRES_DOWN=$(cat /proc/hps/down_threshold)
if [ ${THRES_UP} -ne ${SCHED_UP_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$SCHED_UP_INFO" "/proc/hps/up_threshold"
fi
if [ ${THRES_DOWN} -ne ${SCHED_DOWN_INFO} ] ; then
KERNEL_CHANGED="true"
chwrite "$SCHED_DOWN_INFO" "/proc/hps/down_threshold"
fi
fi
else
if [ -e /proc/sys/kernel/sched_downmigrate ] ; then
SCHED_UP_INFO=$(cat /data/FastTurbo/SmartAI/sched_up)
SCHED_DOWN_INFO=$(cat /data/FastTurbo/SmartAI/sched_down)
chwrite "$(($SCHED_UP_INFO+10))" "/proc/sys/kernel/sched_upmigrate" 
chwrite "$(($SCHED_DOWN_INFO+10))" "/proc/sys/kernel/sched_downmigrate"
fi
if [ -e /proc/hps/up_threshold ] ; then
SCHED_UP_INFO=$(cat /data/FastTurbo/SmartAI/sched_up)
SCHED_DOWN_INFO=$(cat /data/FastTurbo/SmartAI/sched_down)
chwrite "$(($SCHED_UP_INFO+10))" "/proc/hps/up_threshold" 
chwrite "$(($SCHED_DOWN_INFO+10))" "/proc/hps/down_threshold"
fi
fi
if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
NR_RUN=$(cat /proc/sys/kernel/sched_spill_nr_run)
fi
if [ -e /proc/sys/kernel/sched_spill_load ] ; then
SPILL_LOAD=$(cat /proc/sys/kernel/sched_spill_load)
fi
if [ $mode != "powersave" ] ; then
 if [ $OVERTEMP_LEVEL = "0" ] ; then
  if [ ${NR_RUN} -ne "3" ] ; then
   if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
    chwrite "10" /proc/sys/kernel/sched_spill_nr_run
   fi
  fi
if [ ${SPILL_LOAD} -ne "60" ] ; then
 if [ -e /proc/sys/kernel/sched_spill_load ] ; then
  chwrite "85" /proc/sys/kernel/sched_spill_load
 fi
fi
fi
else
if [ ${NR_RUN} -ne "3" ] ; then
if [ -e /proc/sys/kernel/sched_spill_nr_run ] ; then
chwrite "3" /proc/sys/kernel/sched_spill_nr_run
fi
fi
if [ ${SPILL_LOAD} -ne "60" ] ; then
if [ -e /proc/sys/kernel/sched_spill_load ] ; then
chwrite "60" /proc/sys/kernel/sched_spill_load
fi
fi
fi
if [ -e /dev/stune/top-app/schedtune.boost ] ; then
DYNAMIC_BOOST=$(cat /sys/module/cpu_boost/parameters/dynamic_stune_boost)
TOPAPP_BOOST=$(cat /dev/stune/top-app/schedtune.boost)
FOREGROUND_BOOST=$(cat /dev/stune/foreground/schedtune.boost)
BACKGROUND_BOOST=$(cat /dev/stune/background/schedtune.boost)
 if [ $OVERTEMP_LEVEL = "0" ] ; then
  DYNAMIC_BOOST_INFO=$(cat /data/FastTurbo/SmartAI/dynamic_boost)
  TOPAPP_BOOST_INFO=$(cat /data/FastTurbo/SmartAI/topapp_boost)
  FOREGROUND_BOOST_INFO=$(cat /data/FastTurbo/SmartAI/foreground_boost)
  RT_BOOST_NOW=$(cat /dev/stune/rt/schedtune.boost)
  if [ $GAME_BOOST = "true" -o $APP_BOOST = "true" ] ; then
   if [ $mode = "gamexe" ] ; then
    chwrite "50" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
    chwrite "50" "/dev/stune/top-app/schedtune.boost"
    chwrite "40" "/dev/stune/foreground/schedtune.boost"
    chwrite "40" "/dev/stune/rt/schedtune.boost"
   elif [ $mode = "turbo" ] ; then
    chwrite "40" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
    chwrite "40" "/dev/stune/top-app/schedtune.boost"
    chwrite "30" "/dev/stune/foreground/schedtune.boost"
    chwrite "30" "/dev/stune/rt/schedtune.boost"
   else
    chwrite "20" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
    chwrite "20" "/dev/stune/top-app/schedtune.boost"
    chwrite "20" "/dev/stune/foreground/schedtune.boost"
    chwrite "10" "/dev/stune/rt/schedtune.boost"
   fi
  else
   if [ "$DYNAMIC_BOOST" != "$DYNAMIC_BOOST_INFO" ] ; then
    KERNEL_CHANGED="true"
    chwrite "$DYNAMIC_BOOST_INFO" "/sys/module/cpu_boost/parameters/dynamic_stune_boost"
   fi
   if [ "$TOPAPP_BOOST" != "$TOPAPP_BOOST_INFO" ] ; then
    KERNEL_CHANGED="true"
    chwrite "$TOPAPP_BOOST_INFO" "/dev/stune/top-app/schedtune.boost"
   fi
   if [ "$FOREGROUND_BOOST" != "$FOREGROUND_BOOST_INFO" ] ; then
    KERNEL_CHANGED="true"
    chwrite "$FOREGROUND_BOOST_INFO" "/dev/stune/foreground/schedtune.boost"
   fi
   if [ "$RT_BOOST_NOW" != "10" ] ; then
    chwrite "10" "/dev/stune/rt/schedtune.boost"
   fi
  fi 
 fi
 BACKGROUND_BOOST_INFO=$(cat /data/FastTurbo/SmartAI/background_boost)
 if [ "$BACKGROUND_BOOST" != "$BACKGROUND_BOOST_INFO" ] ; then
  KERNEL_CHANGED="true"
  chwrite "$BACKGROUND_BOOST_INFO" "/dev/stune/background/schedtune.boost)"
 fi
fi
CHECK_CPU=$(cat /data/FastTurbo/SmartAI/pwrsv_check)
CHECK_FREQ_INFO=$(cat /data/FastTurbo/SmartAI/pwrsv_freq)
FREQ_CHANGED="false"
if [ $NOW_JP = "true" ] ; then
if [ $JP_FUNCTION = "support" ] ; then
if [ $CHECK_CPU = "cpu0" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu1" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu1/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu2" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu2/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu3" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu3/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu4" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu5" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu5/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu6" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu7" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu8" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu8/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
elif [ $CHECK_CPU = "cpu9" ] ; then
 CHECK_FREQ=$(cat /sys/devices/system/cpu/cpu9/cpufreq/scaling_max_freq)
 if [ ${CHECK_FREQ} -ne ${CHECK_FREQ_INFO} ] ; then
  FREQ_CHANGED="true"
 fi
fi
if [ $FREQ_CHANGED = "true" ] ; then
if [ ${CHANGED_COUNT} -lt 5 ] ; then
CHANGED_COUNT=`echo $(($CHANGED_COUNT+1))`
else
echo "unsupport" > /data/FastTurbo/jp_function
JP_FUNCTION="unsupport"
fi
fi
fi
fi
fi #current_check end
sleep 20
done 
