#!/system/bin/sh
#--------------------------------------------------------------------------------
#FastTurbo SmartMind V1.x                                                          
#Author:@Chenzyadb (xda,coolapk,bilibili,github,gitee)       
#E-Mail:chenzyadb@qq.com 
#Test:@Chinatsu Moss  @Amakuni Moss 
#Opensource Licence : https://gitee.com/chenzyadb/FastTurbo/blob/master/LICENCE
#Copyright © Chenzyadb 2020 All Rights Reserved.
#--------------------------------------------------------------------------------
MIND_PID=$$
echo "$MIND_PID" > /data/FastTurbo/SmartAI/mind_pid
LOG="/data/FastTurbo/SmartAI/core_info.log"
mode=$(cat /data/FastTurbo/mode)
if [ -e /sys/devices/system/cpu/kernel_max ] ; then
core_num=$(cat /sys/devices/system/cpu/kernel_max)
elif [ -d /sys/devices/system/cpu/cpu9/ ] ; then
core_num="9"
elif [ -d /sys/devices/system/cpu/cpu7/ ] ; then
core_num="7"
elif [ -d /sys/devices/system/cpu/cpu5/ ] ; then
core_num="5"
elif [ -d /sys/devices/system/cpu/cpu3/ ] ; then
core_num="3"
fi
soc_special=$(cat /data/FastTurbo/SmartAI/soc_special)
mode=$(cat /data/FastTurbo/mode)
if [ $core_num = "9" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
freq6=$(cat /data/FastTurbo/SmartAI/cpu_freq6)
freq7=$(cat /data/FastTurbo/SmartAI/cpu_freq7)
freq8=$(cat /data/FastTurbo/SmartAI/cpu_freq8)
freq9=$(cat /data/FastTurbo/SmartAI/cpu_freq9)
elif [ $core_num = "7" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
freq6=$(cat /data/FastTurbo/SmartAI/cpu_freq6)
freq7=$(cat /data/FastTurbo/SmartAI/cpu_freq7)
elif [ $core_num = "5" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
freq4=$(cat /data/FastTurbo/SmartAI/cpu_freq4)
freq5=$(cat /data/FastTurbo/SmartAI/cpu_freq5)
elif [ $core_num = "3" ] ; then
freq0=$(cat /data/FastTurbo/SmartAI/cpu_freq0)
freq1=$(cat /data/FastTurbo/SmartAI/cpu_freq1)
freq2=$(cat /data/FastTurbo/SmartAI/cpu_freq2)
freq3=$(cat /data/FastTurbo/SmartAI/cpu_freq3)
fi
restart_time="1"
CHECK_TIME="0"
SINGLE_BOOST="false"
NOW_OVERCURRENT="false"
STOP_CURRENT_CHECK="false"
if [ ! -d /data/FastTurbo/SmartMind/ ] ; then
 mkdir -p /data/FastTurbo/SmartMind/
fi
while true ; do
if [ $mode = "turbo" -o $mode = "balance" ] ; then
 GAME_BOOST=$(cat /data/FastTurbo/SmartAI/game_boost)
 OVERTEMP_LEVEL=$(cat /data/FastTurbo/SmartAI/overtemp_level)
 if [ $GAME_BOOST != "true" -a $OVERTEMP_LEVEL = "0" ] ; then
  #恢复多核工作以判断核心负载情况
  if [ $core_num = "9" ] ; then
   chwrite "0-9" /dev/cpuset/top-app/cpus 
   chwrite "0-9" /dev/cpuset/game/cpus 
  elif [ $core_num = "7" ] ; then
   chwrite "0-7" /dev/cpuset/top-app/cpus 
   chwrite "0-7" /dev/cpuset/game/cpus 
  elif [ $core_num = "5" ] ; then
   chwrite "0-5" /dev/cpuset/top-app/cpus 
   chwrite "0-5" /dev/cpuset/game/cpus 
  elif [ $core_num = "3" ] ; then
   chwrite "0-3" /dev/cpuset/top-app/cpus 
   chwrite "0-3" /dev/cpuset/game/cpus 
  fi
  sleep 0.5  #防止负载未及时分配到小核
  PROCESSES_VALUE_INFO=$(cat /proc/stat | grep processes ) #判断当前process数量,保证抓取的数据长度准确
  PROCESS_VALUE=${PROCESSES_VALUE_INFO:10}
  if [ ${PROCESS_VALUE} -lt 100000 ] ; then
  TEXT_LEN="5"
  elif [ ${PROCESS_VALUE} -lt 1000000 ] ; then
  TEXT_LEN="6"
  elif [ ${PROCESS_VALUE} -lt 10000000 ] ; then
  TEXT_LEN="7"
  elif [ ${PROCESS_VALUE} -lt 100000000 ] ; then
  TEXT_LEN="8"
  fi
  if [ $core_num = "9" ] ; then
   if [ ${freq0} -gt ${freq9} ] ; then
    CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	CPU0_CHECK_VALUE_A=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	CPU9_VALUE_INFO=$(cat /proc/stat | grep cpu9 )
	CPU9_CHECK_VALUE_A=$(echo ${CPU9_VALUE_INFO:5:$TEXT_LEN})
	sleep 1
	CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	CPU0_CHECK_VALUE_B=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	CPU9_VALUE_INFO=$(cat /proc/stat | grep cpu9 )
	CPU9_CHECK_VALUE_B=$(echo ${CPU9_VALUE_INFO:5:$TEXT_LEN})
	SMALL_CHECK_VALUE=$(($CPU9_CHECK_VALUE_B-$CPU9_CHECK_VALUE_A))
	BIG_CHECK_VALUE=$(($CPU0_CHECK_VALUE_B-$CPU0_CHECK_VALUE_A))
   else
    CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	CPU0_CHECK_VALUE_A=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	CPU9_VALUE_INFO=$(cat /proc/stat | grep cpu9 )
	CPU9_CHECK_VALUE_A=$(echo ${CPU9_VALUE_INFO:5:$TEXT_LEN})
	sleep 1
	CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	CPU0_CHECK_VALUE_B=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	CPU9_VALUE_INFO=$(cat /proc/stat | grep cpu9 )
	CPU9_CHECK_VALUE_B=$(echo ${CPU9_VALUE_INFO:5:$TEXT_LEN})
	SMALL_CHECK_VALUE=$(($CPU0_CHECK_VALUE_B-$CPU0_CHECK_VALUE_A))
	BIG_CHECK_VALUE=$(($CPU9_CHECK_VALUE_B-$CPU9_CHECK_VALUE_A))
   fi
  elif [ $core_num = "7" ] ; then
   if [ $soc_special != "5" ] ; then
    if [ ${freq0} -gt ${freq7} ] ; then
     CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_A=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU7_VALUE_INFO=$(cat /proc/stat | grep cpu7 )
	 CPU7_CHECK_VALUE_A=$(echo ${CPU7_VALUE_INFO:5:$TEXT_LEN})
	 sleep 1
	 CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_B=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU7_VALUE_INFO=$(cat /proc/stat | grep cpu7 )
	 CPU7_CHECK_VALUE_B=$(echo ${CPU7_VALUE_INFO:5:$TEXT_LEN})
	 SMALL_CHECK_VALUE=$(($CPU7_CHECK_VALUE_B-$CPU7_CHECK_VALUE_A))
     BIG_CHECK_VALUE=$(($CPU0_CHECK_VALUE_B-$CPU0_CHECK_VALUE_A))
    else
     CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_A=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU7_VALUE_INFO=$(cat /proc/stat | grep cpu7 )
	 CPU7_CHECK_VALUE_A=$(echo ${CPU7_VALUE_INFO:5:$TEXT_LEN})
	 sleep 1
	 CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_B=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU7_VALUE_INFO=$(cat /proc/stat | grep cpu7 )
	 CPU7_CHECK_VALUE_B=$(echo ${CPU7_VALUE_INFO:5:$TEXT_LEN})
	 SMALL_CHECK_VALUE=$(($CPU0_CHECK_VALUE_B-$CPU0_CHECK_VALUE_A))
     BIG_CHECK_VALUE=$(($CPU7_CHECK_VALUE_B-$CPU7_CHECK_VALUE_A))
    fi
   fi
  elif [ $core_num = "5" ] ; then
   if [ ${freq0} -gt ${freq5} ] ; then
     CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_A=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU5_VALUE_INFO=$(cat /proc/stat | grep cpu5 )
	 CPU5_CHECK_VALUE_A=$(echo ${CPU5_VALUE_INFO:5:$TEXT_LEN})
	 sleep 1
	 CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_B=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU5_VALUE_INFO=$(cat /proc/stat | grep cpu5 )
	 CPU5_CHECK_VALUE_B=$(echo ${CPU5_VALUE_INFO:5:$TEXT_LEN})
	 SMALL_CHECK_VALUE=$(($CPU5_CHECK_VALUE_B-$CPU5_CHECK_VALUE_A))
     BIG_CHECK_VALUE=$(($CPU0_CHECK_VALUE_B-$CPU0_CHECK_VALUE_A))
   else
     CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_A=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU5_VALUE_INFO=$(cat /proc/stat | grep cpu5 )
	 CPU5_CHECK_VALUE_A=$(echo ${CPU5_VALUE_INFO:5:$TEXT_LEN})
	 sleep 1
	 CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_B=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU5_VALUE_INFO=$(cat /proc/stat | grep cpu5 )
	 CPU5_CHECK_VALUE_B=$(echo ${CPU5_VALUE_INFO:5:$TEXT_LEN})
	 SMALL_CHECK_VALUE=$(($CPU0_CHECK_VALUE_B-$CPU0_CHECK_VALUE_A))
     BIG_CHECK_VALUE=$(($CPU5_CHECK_VALUE_B-$CPU5_CHECK_VALUE_A))
   fi
  elif [ $core_num = "3" ] ; then
   if [ $soc_special != "0" ] ; then
    if [ ${freq0} -gt ${freq3} ] ; then
     CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_A=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU3_VALUE_INFO=$(cat /proc/stat | grep cpu3 )
	 CPU3_CHECK_VALUE_A=$(echo ${CPU3_VALUE_INFO:5:$TEXT_LEN})
	 sleep 1
	 CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_B=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU3_VALUE_INFO=$(cat /proc/stat | grep cpu3 )
	 CPU3_CHECK_VALUE_B=$(echo ${CPU3_VALUE_INFO:5:$TEXT_LEN})
	 SMALL_CHECK_VALUE=$(($CPU3_CHECK_VALUE_B-$CPU3_CHECK_VALUE_A))
     BIG_CHECK_VALUE=$(($CPU0_CHECK_VALUE_B-$CPU0_CHECK_VALUE_A))
    else
     CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_A=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU3_VALUE_INFO=$(cat /proc/stat | grep cpu3 )
	 CPU3_CHECK_VALUE_A=$(echo ${CPU3_VALUE_INFO:5:$TEXT_LEN})
	 sleep 1
	 CPU0_VALUE_INFO=$(cat /proc/stat | grep cpu0 )
	 CPU0_CHECK_VALUE_B=$(echo ${CPU0_VALUE_INFO:5:$TEXT_LEN})
	 CPU3_VALUE_INFO=$(cat /proc/stat | grep cpu3 )
	 CPU3_CHECK_VALUE_B=$(echo ${CPU3_VALUE_INFO:5:$TEXT_LEN})
	 SMALL_CHECK_VALUE=$(($CPU0_CHECK_VALUE_B-$CPU0_CHECK_VALUE_A))
     BIG_CHECK_VALUE=$(($CPU3_CHECK_VALUE_B-$CPU3_CHECK_VALUE_A))
    fi
   fi
  fi
  #判断大核小核负载情况
   FZ_VALUE_NOW=$(($BIG_CHECK_VALUE-$SMALL_CHECK_VALUE))
   if [ -e /data/FastTurbo/SmartMind/fz_value ] ; then
    FZ_VALUE_INFO=$(cat /data/FastTurbo/SmartMind/fz_value)
    FZ_COUNT_TIME=$(cat /data/FastTurbo/SmartMind/fz_time)
	if [ ${FZ_VALUE_NOW} -gt 0 -a ${FZ_VALUE_NOW} -lt 30 ] ; then
     if [ ${FZ_COUNT_TIME} -lt 1000 ] ; then
      echo $(($FZ_VALUE_INFO+$FZ_VALUE_NOW)) > /data/FastTurbo/SmartMind/fz_value
      echo $(($FZ_COUNT_TIME+1)) > /data/FastTurbo/SmartMind/fz_time
     else
      echo $(($FZ_VALUE_INFO/5)) > /data/FastTurbo/SmartMind/fz_value
      echo "200" > /data/FastTurbo/SmartMind/fz_time
     fi
    fi
   else
    FZ_COUNT_TIME="1"
    echo $FZ_VALUE_NOW > /data/FastTurbo/SmartMind/fz_value
    echo "1" > /data/FastTurbo/SmartMind/fz_time
   fi
   if [ ${FZ_COUNT_TIME} -lt 20 ] ; then
    FZ_CHECK_VALUE="10"
   else
    FZ_CHECK_VALUE=$(($FZ_VALUE_INFO/$FZ_COUNT_TIME+5))
   fi
   if [ ${FZ_VALUE_NOW} -gt ${FZ_CHECK_VALUE} ] ; then
    if [ $SINGLE_BOOST = "false" ] ; then
     echo "[LOG][$(date +%T)] 检测到单线程负载增加,已调整核心分配." |  tee -a $LOG;
    fi
    restart_time="4"
    SINGLE_BOOST="true"
    if [ $core_num = "9" ] ; then
     if [ ${freq0} -gt ${freq9} ] ; then
	  chwrite "0-1" /dev/cpuset/top-app/cpus 
	  chwrite "0-1" /dev/cpuset/top-app/boost/cpus 
	  chwrite "0-1" /dev/cpuset/game/cpus 
	 else
	  chwrite "8-9" /dev/cpuset/top-app/cpus 
	  chwrite "8-9" /dev/cpuset/top-app/boost/cpus 
	  chwrite "8-9" /dev/cpuset/game/cpus 
	 fi
    elif [ $core_num = "7" ] ; then
     if [ $soc_special = "0" -o $soc_special = "3" ] ; then
	  if [ ${freq0} -gt ${freq7} ] ; then
	   chwrite "0-3" /dev/cpuset/top-app/cpus 
	   chwrite "0-3" /dev/cpuset/top-app/boost/cpus 
	   chwrite "0-3" /dev/cpuset/game/cpus 
	  else
	   chwrite "4-7" /dev/cpuset/top-app/cpus 
	   chwrite "4-7" /dev/cpuset/top-app/boost/cpus 
	   chwrite "4-7" /dev/cpuset/game/cpus 
	  fi
	 elif [ $soc_special = "1" ] ; then
	  if [ ${freq0} -gt ${freq7} ] ; then
	   chwrite "0-1" /dev/cpuset/top-app/cpus 
	   chwrite "0-1" /dev/cpuset/top-app/boost/cpus 
	   chwrite "0-1" /dev/cpuset/game/cpus 
	  else
	   chwrite "6-7" /dev/cpuset/top-app/cpus 
	   chwrite "6-7" /dev/cpuset/top-app/boost/cpus 
	   chwrite "6-7" /dev/cpuset/game/cpus 
	  fi
	 fi
    elif [ $core_num = "5" ] ; then
	 if [ ${freq0} -gt ${freq5} ] ; then
	  chwrite "0-1" /dev/cpuset/top-app/cpus 
	  chwrite "0-1" /dev/cpuset/top-app/boost/cpus 
	  chwrite "0-1" /dev/cpuset/game/cpus 
	 else
	  chwrite "4-5" /dev/cpuset/top-app/cpus 
	  chwrite "4-5" /dev/cpuset/top-app/boost/cpus 
	  chwrite "4-5" /dev/cpuset/game/cpus 
	 fi
    elif [ $core_num = "3" ] ; then
     if [ $soc_special != "0" ] ; then
	 if [ ${freq0} -gt ${freq3} ] ; then
	  chwrite "0-1" /dev/cpuset/top-app/cpus 
	  chwrite "0-1" /dev/cpuset/top-app/boost/cpus 
	  chwrite "0-1" /dev/cpuset/game/cpus 
	 else
	  chwrite "2-3" /dev/cpuset/top-app/cpus 
	  chwrite "2-3" /dev/cpuset/top-app/boost/cpus 
	  chwrite "2-3" /dev/cpuset/game/cpus 
	 fi
    fi
   fi
   else
	if [ $SINGLE_BOOST = "true" ] ; then 
	 echo "[LOG][$(date +%T)] 检测到单线程负载降低,已调整核心分配." |  tee -a $LOG;
	fi
	SINGLE_BOOST="false"
	restart_time="1"
   fi 
 else
  #初始化
  restart_time="1"
  CHECK_TIME="0"
  SINGLE_BOOST="false"
 fi
fi
if [ $mode = "balance" -o $mode = "powersave" ] ; then
 restart_time="10"
 OVERTEMP_LEVEL=$(cat /data/FastTurbo/SmartAI/overtemp_level)
 APP_BOOST=$(cat /data/FastTurbo/SmartAI/app_boost)
 if [ $OVERTEMP_LEVEL = "0" -a $APP_BOOST = "false" ] ; then
  if [ $STOP_CURRENT_CHECK = "true" ] ; then
   echo "[LOG][$(date +%T)] 温控动作已停止,异常耗电监测恢复." |  tee -a $LOG;
   STOP_CURRENT_CHECK="false"
  fi
  #Get Battry Current
  BATT_CURRENT1="0"
  BATT_CURRENT2="0"
  BATT_CURRENT3="0"
  BATT_CURRENT4="0"
  if [ -d /sys/class/power_supply/battery/ ] ; then
   BATT_CURRENT1=$(cat /sys/class/power_supply/battery/current_now)
   sleep 1
   BATT_CURRENT2=$(cat /sys/class/power_supply/battery/current_now)
   sleep 1
   BATT_CURRENT3=$(cat /sys/class/power_supply/battery/current_now)
   sleep 1
   BATT_CURRENT4=$(cat /sys/class/power_supply/battery/current_now)
  elif [ -d /sys/class/power_supply/Battery/ ] ; then
   BATT_CURRENT1=$(cat /sys/class/power_supply/Battery/current_now)
   sleep 1
   BATT_CURRENT2=$(cat /sys/class/power_supply/Battery/current_now)
   sleep 1
   BATT_CURRENT3=$(cat /sys/class/power_supply/Battery/current_now)
   sleep 1
   BATT_CURRENT4=$(cat /sys/class/power_supply/Battery/current_now)
  fi
  #判断最大最小电流值
  SAVE_CURRENT_NOW="0"
  NOW_CURRENT_INFO="1000000"
  for a in $BATT_CURRENT1 $BATT_CURRENT2 $BATT_CURRENT3 $BATT_CURRENT4 ; do
   if [ ${a} -gt ${SAVE_CURRENT_NOW} ] ; then
    SAVE_CURRENT_NOW=$(echo $a)
   fi
  done
  for b in $BATT_CURRENT1 $BATT_CURRENT2 $BATT_CURRENT3 $BATT_CURRENT4 ; do
   if [ ${b} -lt ${NOW_CURRENT_INFO} ] ; then
    NOW_CURRENT_INFO=$(echo $b)
   fi
  done
  if [ ${SAVE_CURRENT_NOW} -gt 800000 ] ; then
   SAVE_CURRENT_NOW="800000"
  fi  
  if [ ! -e /data/FastTurbo/SmartMind/average_current ] ; then #创建全新的电流数据
   CURRENT_COUNT_TIME="1"
   echo "1" > /data/FastTurbo/SmartMind/count_time
   echo "$(($SAVE_CURRENT_NOW/100))" > /data/FastTurbo/SmartMind/average_current
  else #更新已存储的数据
   AVERAGE_CURRENT_INFO=$(cat /data/FastTurbo/SmartMind/average_current)
   CURRENT_COUNT_TIME=$(cat /data/FastTurbo/SmartMind/count_time)
   if [ ${CURRENT_COUNT_TIME} -eq 500 ] ; then
    echo "100" > /data/FastTurbo/SmartMind/count_time
	echo "$(($AVERAGE_CURRENT_INFO/5))" > /data/FastTurbo/SmartMind/average_current
   else
    echo "$(($CURRENT_COUNT_TIME+1))" > /data/FastTurbo/SmartMind/count_time
	WRITE_CURRENT_INFO=$(($SAVE_CURRENT_NOW/100))
	echo "$(($AVERAGE_CURRENT_INFO+$WRITE_CURRENT_INFO))" > /data/FastTurbo/SmartMind/average_current
   fi
  fi
  if [ ${CURRENT_COUNT_TIME} -lt 20 ] ; then
   OVER_CURRENT_VALUE="800000"
  else
   if [ $mode = "powersave" ] ; then
    OVER_CURRENT_VALUE=$(($AVERAGE_CURRENT_INFO/$CURRENT_COUNT_TIME*100))
   elif [ $mode = "balance" ] ; then
    OVER_CURRENT_VALUE=$(($AVERAGE_CURRENT_INFO/$CURRENT_COUNT_TIME*100+100000))
   fi
  fi
  if [ ${NOW_CURRENT_INFO} -gt ${OVER_CURRENT_VALUE} ] ; then
   if [ $NOW_OVERCURRENT = "false" ] ; then
    echo "[LOG][$(date +%T)] 当前电池电流 $(($NOW_CURRENT_INFO/1000)) mA,限制电流 $(($OVER_CURRENT_VALUE/1000)) mA,将限制性能以提升续航." |  tee -a $LOG;
   fi
   NOW_OVERCURRENT="true"
   chmod 7777 /system/etc/init.sa.overcurrent.sh
   su -c sh /system/etc/init.sa.overcurrent.sh &
  else
   if [ $NOW_OVERCURRENT = "true" ] ; then
    echo "[LOG][$(date +%T)] 当前电池电流 $(($NOW_CURRENT_INFO/1000)) mA属正常范围,已恢复原始性能." |  tee -a $LOG;
   fi
   NOW_OVERCURRENT="false"
  fi
 else
  if [ $STOP_CURRENT_CHECK = "false" ] ; then
   echo "[LOG][$(date +%T)] 当前SOC温度过高触发温控,已暂停异常耗电监测." |  tee -a $LOG;
   STOP_CURRENT_CHECK="true"
  fi
 fi
fi
sleep $restart_time
done

